#ifndef DEFINES_H
#define DEFINES_H




#ifdef STORE_HERE
char NagText[] = "IMPORTANT NOTICE\r\n\r\nThis software provides mechanisms for viewing and editing(*) the contents of certain pinball machine ROM images.  It is up to you to determine if this software can be used without violating any agreements that prohibits you from using this software.  For example there may have been an agreement you agreed to when you obtained the ROM image.  Additionally, you may be bound to an implicit agreement if your pinball machine came with a manual.  The back cover of the manual may contain verbage that may make the use of this software a violation of the agreement.\r\n\r\nBy clicking the \'I understand and agree\' button below, you acknowledge that you have read the text in this dialog box and accept responsibility for using this software in an appropriate manner.  You also recognize that modifying the contents of the ROM image can be potentially catastrophic to your pinball machine.  For example if you change a byte from a value of 5 to 200 and this byte in the ROM happened to be the number of milliseconds to energize a flasher, then this example ROM modification would cause the flasher bulb to burn out when the game tries to energize the flasher.\r\n\r\nPlease do not distribute modified ROM images that may have been generated by this software(*) or from any other source.  This software is intended for personal use only and may not be used in a comercial environment.  Please click \'I do not agree\' if you feel that using this software is legally, morally, or ethically wrong.\r\n\r\n(*) Not all versions of this software will have edit capabilities.";
char DMDNagText[] = "IMPORTANT NOTICE\r\n\r\nThe DMD images that this software extracts from the ROM is copyrighted material.  Please treat the images produced by this software as you would treat a photograph that belonged to somebody else.  It is advised that you do not use any of the images on a web page, auction page, or any such public posting.\r\n\r\nAdditionally some game ROMs contain private images of the designers loved ones and family members.  Please respect the privacy of these individuals and do NOT reproduce, copy or otherwise make public such images.";    
#else
extern char NagText[];
extern char DMDNagText[];
#endif


#define PIXEL_COLORS   7 //Grey,Red,Yellow,Green,Teal,Blue,Violet
#define PIXEL_SHADES   3 //Dim,Medium,Bright

#define PIXEL_COLOR_GREY    0
#define PIXEL_COLOR_RED     1 
#define PIXEL_COLOR_YELLOW  2
#define PIXEL_COLOR_GREEN   3
#define PIXEL_COLOR_TEAL    4
#define PIXEL_COLOR_BLUE    5
#define PIXEL_COLOR_VIOLET  6

#ifdef STORE_HERE
char ColorText [PIXEL_COLORS][16] = 
	{
		"Grey",
		"Red",
		"Yellow",
		"Green",
		"Teal",
		"Blue",
		"Violet"
	};
#else
extern char ColorText [PIXEL_COLORS][16];
#endif

#define PIXEL_SHADE_DIM     0
#define PIXEL_SHADE_MEDIUM  1
#define PIXEL_SHADE_BRIGHT  2

#define DEFAULT_PIXEL_COLOR     PIXEL_COLOR_YELLOW

#define NORMAL_XORED_COLOR      PIXEL_COLOR_GREEN
#define ALTERNATE_XORED_COLOR   PIXEL_COLOR_RED
#define NORMAL_SKIPPED_COLOR    PIXEL_COLOR_GREY
#define ALTERNATE_SKIPPED_COLOR PIXEL_COLOR_BLUE


#define REGISTRY_DMDEDIT_SETTINGS  "DMDEditSettings"
#define REGISTRY_OVERALL_SETTINGS  "ProgramSettings"
#define REGISTRY_NAG_SCREENS       "NagScreens"

#define DEFAULT_XORCHECKBOXSTATE   1
#define DEFAULT_SKIPCHECKBOXSTATE  1
#define DEFAULT_UNLOCKKEY 0x00000000

#define MAX_NAGS                       1
#define NAG_INDEX_DMD_ENTERKEY_TIP     0
//#define NAG_INDEX_TEST                 1

#ifdef STORE_HERE
char NagRegistryKeyText[MAX_NAGS][64] =
{
	"DMDEnterKeyInfo",
};
#else
extern char NagRegistryKeyText[MAX_NAGS][64];
#endif

#ifdef STORE_HERE
char NagTexts[MAX_NAGS][128] = 
{
	"Tip: Hold the Enter key to rapidly cycle through the DMD images.",
};
#else
extern char NagTexts[MAX_NAGS][128];
#endif

struct RegistrySettings
{
	//long UnlockKey;
	int	PixelColor;
	unsigned char XoredCheckboxState;
	unsigned char SkippedCheckboxState;
	unsigned char NagMessageShown;
	unsigned char MiscNagsShown[MAX_NAGS];
	unsigned char DMDNagMessageShown;
	//
	// The following value(s) are not written to the registry but
	// placed into this structure so they can be passed around to
	// different dialogs easily...
	//
	//long DiskId;
};


#define TIMER_ABOUTICON_INITIAL   1000
#define TIMER_ABOUTICON_AXED      1500
#define TIMER_ABOUTICON_ANIMATING  100

#define TIMER_WINDOW_ICONS_UPDATE 1000
#define TIMER_DMD_UPDATE            30

#define TIMER_WINDOW_ICONS  3
#define TIMER_ABOUT_ICON    4
//#define TIMER_DMD           5

#define DMD_DIALOG_TYPE_GRAPHICS   1
#define DMD_DIALOG_TYPE_FONTDATA   2
#define DMD_DIALOG_TYPE_ANIDATA    3

//
// Global function prototypes...
//
long getHardDriveComputerID ();


#endif // ends file wrapper