// DMD.cpp : implementation file
//

#include "stdafx.h"
#include "defines.h"
#include "HexEditor.h"
#include "DMD.h"
#include "hexeditordoc.h"
#include "hexeditorview.h"
#include "mybutton.h"
#include "nagdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define ALLOW_MOUSE_TO_REPEAT    (0)

//
// Games verified to work (only checked a few DMD images to consider good)
// -----------------------------------------------------------------------
// Attack From Mars 1.13
// Cactus Canyon 1.3              **8 MEG**
// Champion Pub 1.6
// Cirqus Voltaire 1.4            **8 MEG**
// Congo 2.1
// Corvette 2.1
// Demolition Man LX4
// Dirty Harry LX2
// Flintstones LX5
// Indiana Jones L7
// Indianopolis 500 1.1R
// Jackbot 1.0R
// Johnny Mnemonic 1.2R
// Judge Dredd L7
// Junkyard 1.2
// Medievil Madness 1.09H         **8 MEG**
// Monster Bash 1.06
// NBA Fastbreak 3.1
// No Fear 2.3X
// No Good Gofers 1.3
// Popeye LX5
// Roadshow L6
// Safe Cracker 1.8G
// Scared Stiff 1.5
// Shadow LX6
// Star Trek Next Generation L7
// Theater of Magic 1.3
// Ticket Tac Toe 1.0
// Twilight Zone 9.4H
// Who Dunnit 1.2
// World Cup Soccer LX2
//
//
// 
// Games NOT working at this time
// ------------------------------
// *Addams Family L5, H4
// *Addams Family Gold H3
// Black Rose L3
// *Creature from the black lagoon L4
// *Dracula L1
// *Dr. Who L2
// Fish Tales L5
// Gilligans Island L9
// High Speed II Getaway L5
// *Hurricane L2
// Slugfest L1
// Tales of the Arabian Nights 1.4
// Terminator 2 L8
// White Water L5
//
// WPC, but no DMD!
// ----------------
// Funhouse
// Harley Davidson
// League Champ
// Party Zone
// Strike Master
// The Machine bride of pinbot
// 
// 
//
//
/////////////////////////////////////////////////////////////////////////////
// DMD dialog


DMD::DMD(CWnd* pParent /*=NULL*/,RegistrySettings *mainptr)
	: CDialog(DMD::IDD, pParent)
{
	PassedInPointer = mainptr;
	NaggedOnce = 0;
	//{{AFX_DATA_INIT(DMD)
	//}}AFX_DATA_INIT
}

DMD::~DMD()
{
}
void DMD::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DMD)
	DDX_Control(pDX, IDC_SPIN1, m_Spin);
	DDX_Control(pDX, IDC_LIST1, m_PixelColor);
	DDX_Control(pDX, IDC_CHECK_XORED, m_Xored);
	DDX_Control(pDX, IDC_CHECK_SKIPPED, m_Skipped);
	DDX_Control(pDX, IDC_STATIC_BOTH, m_Both);
	DDX_Control(pDX, IDC_STATIC_MEDIUM, m_Medium);
	DDX_Control(pDX, IDC_STATIC_DIM, m_Dim);
	DDX_Control(pDX, IDC_BUTTON_NEXT_GRAPHIC, m_NextGraphic);
	DDX_Control(pDX, IDC_BUTTON_PREVIOUS_GRAPHIC, m_PreviousGraphic);
	DDX_Control(pDX, IDC_STATIC_USERREG, m_UserReg);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DMD, CDialog)
	//{{AFX_MSG_MAP(DMD)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_NEXT_GRAPHIC, OnButtonNextGraphic)
	ON_BN_CLICKED(IDC_BUTTON_PREVIOUS_GRAPHIC, OnButtonPreviousGraphic)
	ON_BN_CLICKED(IDC_CHECK_SKIPPED, OnCheckSkipped)
	ON_BN_CLICKED(IDC_CHECK_XORED, OnCheckXored)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_WM_CLOSE()
	ON_WM_CTLCOLOR()
	ON_WM_SHOWWINDOW()
	ON_WM_TIMER()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DMD message handlers

BOOL DMD::Create() 
{
	// TODO: Add your specialized code here and/or call the base class
//	WindowValid = TRUE;

	return CDialog::Create(DMD::IDD);
}

BOOL DMD::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::Create(IDD, pParentWnd);
}

int DMD::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO: Add your specialized creation code here
	return 0;
}

void DMD::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
}

BOOL DMD::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_PixelColor.AddString("Black&White");
	m_PixelColor.AddString("Red");
	m_PixelColor.AddString("Yellow");
	m_PixelColor.AddString("Green");
	m_PixelColor.AddString("Teal");
	m_PixelColor.AddString("Blue");
	m_PixelColor.AddString("Violet");
	m_PixelColor.SetTopIndex(PassedInPointer->PixelColor);
	m_Spin.SetPos(PassedInPointer->PixelColor);
	m_Xored.SetCheck(PassedInPointer->XoredCheckboxState);
	m_Skipped.SetCheck(PassedInPointer->SkippedCheckboxState);
//#if !SPECIAL_UNLOCK_BUILD
#ifndef UNLOCKBUILD
 #ifdef PUBLIC_RELEASE
	CString RegString;
	RegString.Format("Public Release February 5, 2005");
	m_UserReg.SetWindowText(RegString);
 #else
//	m_UserReg.SetWindowText(RegisteredUser);
	CString RegString;
	RegString.Format("%s%s",RegisteredText, RegisteredUser);
	m_UserReg.SetWindowText(RegString);
 #endif
#endif
#if ALLOW_MOUSE_TO_REPEAT
	TimerIDDMD = SetTimer(TIMER_DMD, TIMER_DMD_UPDATE, NULL);
	NextDebounce =
	PreviousDebounce = 0;
	NextDebounceState =
	PreviousDebounceState = DEBOUNCE_STATE_IDLE;
#endif
//	NextPressed = 
//	PreviousPressed = 0;
	UpdateControls();



	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DMD::OnPaint() 
{
//#if !SPECIAL_UNLOCK_BUILD
#ifndef UNLOCKBUILD
	CPaintDC dc(this); // device context for painting

	const char *XorPtr;
	unsigned int  ii;
	unsigned char XorValue;
	unsigned char XorSum;

	// TODO: Add your message handler code here
	int i,j,k;
	int RowIndex, ColumnIndex;
	unsigned char ReadMask;
	unsigned char PLANE_BITS;
	unsigned char *Plane_0Ptr      = Data.Plane_0;
	unsigned char *Plane_0Xored    = Data.Plane_0Xored;
	unsigned char *Plane_0Skipped  = Data.Plane_0Skipped;
	unsigned char *Plane_1Ptr      = Data.Plane_1;
	unsigned char *Plane_1Xored    = Data.Plane_1Xored;
	unsigned char *Plane_1Skipped  = Data.Plane_1Skipped;
	unsigned char XoredCheck = m_Xored.GetCheck();
	unsigned char SkippedCheck = m_Skipped.GetCheck();

	const int PixelColorIDs[PIXEL_COLORS][PIXEL_SHADES] = 
	{
		IDB_BITMAP_PIXEL_GREYDIM,
		IDB_BITMAP_PIXEL_GREYMEDIUM,
		IDB_BITMAP_PIXEL_GREYBRIGHT,
		IDB_BITMAP_PIXEL_REDDIM,
		IDB_BITMAP_PIXEL_REDMEDIUM,
		IDB_BITMAP_PIXEL_REDBRIGHT,
		IDB_BITMAP_PIXEL_YELLOWDIM,
		IDB_BITMAP_PIXEL_YELLOWMEDIUM,
		IDB_BITMAP_PIXEL_YELLOWBRIGHT,
		IDB_BITMAP_PIXEL_GREENDIM,
		IDB_BITMAP_PIXEL_GREENMEDIUM,
		IDB_BITMAP_PIXEL_GREENBRIGHT,
		IDB_BITMAP_PIXEL_TEALDIM,
		IDB_BITMAP_PIXEL_TEALMEDIUM,
		IDB_BITMAP_PIXEL_TEALBRIGHT,
		IDB_BITMAP_PIXEL_BLUEDIM,
		IDB_BITMAP_PIXEL_BLUEMEDIUM,
		IDB_BITMAP_PIXEL_BLUEBRIGHT,
		IDB_BITMAP_PIXEL_VIOLETDIM,
		IDB_BITMAP_PIXEL_VIOLETMEDIUM,
		IDB_BITMAP_PIXEL_VIOLETBRIGHT
	};

	CString Reg;
	m_UserReg.GetWindowText(Reg);
	if ((Reg.GetLength()) != (REG_LENGTH + REGTEXT_LENGTH))
	{
#ifdef PUBLIC_RELEASE
		CString RegString;
		RegString.Format("Public Release February 5, 2005");
		m_UserReg.SetWindowText(RegString);
#else
		CString RegString;
		RegString.Format("%s%s",RegisteredText, RegisteredUser);
		m_UserReg.SetWindowText(RegString);
#endif
	}

	CDC hOff;
	CDC hXored;
	CDC hSkipped;
	CDC hMedium;
	CDC hDim;
	CDC hBright;

	

	j = 0;
//	j += hOff.CreateCompatibleDC(&dc);
//	j += hXored.CreateCompatibleDC(&dc);
//	j += hSkipped.CreateCompatibleDC(&dc);
//	j += hDim.CreateCompatibleDC(&dc);
//	j += hMedium.CreateCompatibleDC(&dc);
//	j += hBright.CreateCompatibleDC(&dc);
	j += hOff.CreateCompatibleDC(NULL);
	j += hXored.CreateCompatibleDC(NULL);
	j += hSkipped.CreateCompatibleDC(NULL);
	j += hDim.CreateCompatibleDC(NULL);
	j += hMedium.CreateCompatibleDC(NULL);
	j += hBright.CreateCompatibleDC(NULL);
	if (j != 6)
	{
		AfxMessageBox("Problem loading pixels.");
		return;
	}

	CBitmap BMOff;
	CBitmap BMXored;
	CBitmap BMSkipped;
	CBitmap BMDim;
	CBitmap BMMedium;
	CBitmap BMBright;

	UpdateCheckboxText();

	i = m_PixelColor.GetTopIndex();
	if (i > PIXEL_COLORS)
		i = PIXEL_COLORS;

	j = 0;
	j += BMOff.LoadBitmap(IDB_BITMAP_PIXEL_BLACK);
	if (i == NORMAL_XORED_COLOR)
		j += BMXored.LoadBitmap(PixelColorIDs[ALTERNATE_XORED_COLOR][PIXEL_SHADE_BRIGHT]);
	else
		j += BMXored.LoadBitmap(PixelColorIDs[NORMAL_XORED_COLOR][PIXEL_SHADE_BRIGHT]);

	if (i == NORMAL_SKIPPED_COLOR)
		j += BMSkipped.LoadBitmap(PixelColorIDs[ALTERNATE_SKIPPED_COLOR][PIXEL_SHADE_DIM]);
	else
		j += BMSkipped.LoadBitmap(PixelColorIDs[NORMAL_SKIPPED_COLOR][PIXEL_SHADE_DIM]);
	j += BMDim.LoadBitmap(PixelColorIDs[i][PIXEL_SHADE_DIM]);
	j += BMMedium.LoadBitmap(PixelColorIDs[i][PIXEL_SHADE_MEDIUM]);
	j += BMBright.LoadBitmap(PixelColorIDs[i][PIXEL_SHADE_BRIGHT]);

	if (j != 6)
	{
		AfxMessageBox("Problem loading pixel bitmaps.");
		return;
	}
	j = 0;
	CBitmap *old_hOff = hOff.SelectObject(&BMOff);
	if (old_hOff)
		j++;
	CBitmap *old_hXored = hXored.SelectObject(&BMXored);
	if (old_hXored)
		j++;
	CBitmap *old_hSkipped = hSkipped.SelectObject(&BMSkipped);
	if (old_hSkipped)
		j++;
	CBitmap *old_hDim = hDim.SelectObject(&BMDim);
	if (old_hDim)
		j++;
	CBitmap *old_hMedium = hMedium.SelectObject(&BMMedium);
	if (old_hMedium)
		j++;
	CBitmap *old_hBright = hBright.SelectObject(&BMBright);
	if (old_hBright)
		j++;

	if (j != 6)
	{
		AfxMessageBox("Problem loading pixel bitmap objects.");
		return;
	}
	
	for (i = 0; i < DMD_ROWS; i++)
	{
		for (ii = XorValue = 0,XorSum = XOR_SEED,XorPtr=&RegisteredUser[0]; ii < strlen(RegisteredUser); ii++)
		{
			XorValue ^= *XorPtr++;
			XorSum   += XorValue;
		}

		m_UserReg.GetWindowText(Reg);
		if ((Reg.GetLength()) != (REG_LENGTH + REGTEXT_LENGTH))
		{
#ifdef PUBLIC_RELEASE
			CString RegString;
			RegString.Format("Public Release February 5, 2005");
			m_UserReg.SetWindowText(RegString);
#else
			CString RegString;
			RegString.Format("%s%s",RegisteredText, RegisteredUser);
			m_UserReg.SetWindowText(RegString);
#endif
		}

		for (j = 0; j < (DMD_COLUMNS/8); j++)
		{
			for (ReadMask = 0x01, k = 0; k < 8; k++,ReadMask <<= 1)
			{
				PLANE_BITS = 0x00;
				if (*Plane_0Ptr & ReadMask)
					PLANE_BITS |= PLANE0_ON;
				if (*Plane_0Xored & ReadMask)
					PLANE_BITS |= PLANE0_XORED;
				if (*Plane_0Skipped & ReadMask)
					PLANE_BITS |= PLANE0_SKIPPED;
				if (*Plane_1Ptr & ReadMask)
					PLANE_BITS |= PLANE1_ON;
				if (*Plane_1Xored & ReadMask)
					PLANE_BITS |= PLANE1_XORED;
				if (*Plane_1Skipped & ReadMask)
					PLANE_BITS |= PLANE1_SKIPPED;
				PLANE_BITS ^= REG_XORSUM;
				//
				// Determine what color to show for medium colored plane
				//
				ColumnIndex = ((((j * 8) + k)) * PIXEL_WIDTH);
				RowIndex = (i * PIXEL_HEIGHT);

				if ((PLANE_BITS ^ XorSum) & PLANE0_ON)
					dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hMedium,0,0,SRCCOPY);
				else if ((PLANE_BITS ^ XorSum) & PLANE0_XORED)
				{
					if (XoredCheck)
						dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hXored,0,0,SRCCOPY);
					else
						dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hMedium,0,0,SRCCOPY);
				}
				else if ((PLANE_BITS ^ XorSum) & PLANE0_SKIPPED)
				{
					if (SkippedCheck)
						dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hSkipped,0,0,SRCCOPY);
					else
						dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hOff,0,0,SRCCOPY);
				}
				else
					dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hOff,0,0,SRCCOPY);
				
				PLANE_BITS ^= XorSum;

				RowIndex += ((DMD_ROWS + 1) * PIXEL_HEIGHT);
				//
				// Determine what color to show for dim plane
				//
				if (PLANE_BITS & PLANE1_ON)
					dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hDim,0,0,SRCCOPY);
				else if (PLANE_BITS & PLANE1_XORED)
				{
					if (XoredCheck)
						dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hXored,0,0,SRCCOPY);
					else
						dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hDim,0,0,SRCCOPY);
				}
				else if (PLANE_BITS & PLANE1_SKIPPED)
				{
					if (SkippedCheck)
						dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hSkipped,0,0,SRCCOPY);
					else
						dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hOff,0,0,SRCCOPY);
				}
				else
					dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hOff,0,0,SRCCOPY);

				RowIndex += ((DMD_ROWS + 1) * PIXEL_HEIGHT);
				//
				// Determine what color to show for blended plane
				//
				if ((PLANE_BITS & (PLANE0_ON | PLANE1_ON)) == (PLANE0_ON | PLANE1_ON))
					dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hBright,0,0,SRCCOPY);
				else if (PLANE_BITS & PLANE0_ON)
					dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hMedium,0,0,SRCCOPY);
				else if (PLANE_BITS & PLANE1_ON)
					dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hDim,0,0,SRCCOPY);
				else
					dc.BitBlt(ColumnIndex,RowIndex,PIXEL_WIDTH,PIXEL_HEIGHT,&hOff,0,0,SRCCOPY);
			}
			Plane_0Ptr++;
			Plane_1Ptr++;
		}
	}
	hOff.SelectObject(old_hOff);
	hXored.SelectObject(old_hXored);
	hSkipped.SelectObject(old_hSkipped);
	hDim.SelectObject(old_hDim);
	hMedium.SelectObject(old_hMedium);
	hBright.SelectObject(old_hBright);

//	hOff.Detach();
//	hXored.Detach();
//	hSkipped.Detach();
//	hDim.Detach();
//	hMedium.Detach();
//	hBright.Detach();

//	BMOff.Detach();
//	BMXored.Detach();
//	BMSkipped.Detach();
//	BMDim.Detach();
//	BMMedium.Detach();
//	BMBright.Detach();

	// Do not call CDialog::OnPaint() for painting messages
#endif
}


unsigned char DMD::Init()
{
//#if !SPECIAL_UNLOCK_BUILD
#ifndef UNLOCKBUILD
	//
	// 30 8B 58 49 30 8B
	// Search
	//
	const char *XorPtr = &RegisteredUser[REG_LENGTH];
	unsigned int  ii,jj;
	unsigned char XorValue   = 0x00;
	unsigned char XorSum     = XOR_SEED;
	jj = strlen(RegisteredUser);
	for (ii = 0,XorPtr-=REG_LENGTH; ii < jj; ii++)
	{
		XorValue ^= *XorPtr++;
		XorSum   += XorValue;
	}

	int i,j;
	CHexEditorDoc *DocPtr = (((CHexEditorView *)((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView())->GetDocument());
	ASSERT_VALID(DocPtr);

	unsigned long TableAddressAddress;
	unsigned char TablePageByte;

	unsigned long Length = DocPtr->m_nBufferLength;
	LPTSTR Ptr = DocPtr->m_szDataBuffer.GetBuffer(Length);
	LPTSTR LocalPtr;
	unsigned char Page;
	unsigned char Search1Hit;
	unsigned char Search2Hit;
	unsigned char Search1Found;
	unsigned char Search2Found;
	unsigned char TempByte;
	unsigned char TotalPages;
	unsigned int TempUint;

	unsigned int RomXor;
	unsigned int RomSum;

#if CURRENT_USER == 004
	if (Length != 0x80000)
	{
ErrorReturn:
		AfxMessageBox("This version of WPCEdit will only work with an original WhoDunnit 1.2 ROM");
		return 0;
	}
#elif CURRENT_USER == 005
	if (Length != 0x80000)
	{
ErrorReturn:
		AfxMessageBox("This version of WPCEdit will only work with an original RoadShow L6 ROM");
		return 0;
	}
#else
	if ((Length != 0x40000) && (Length != 0x80000) && (Length != 0x100000))
	{
		AfxMessageBox("ROM doesn't appear to be a WPC rom image");
		return 0;
	}
#endif
	RomXor = -1;
	RomSum = 0;
	Page = 0x80;
	TempUint = 0;
	for (i = 0; (unsigned int)i < Length; i++)
	{
		RomXor ^= *Ptr;
		Page ^= RomXor;
		RomSum += *Ptr++;
		TempUint -= (Page + RomSum);
	}
#if CURRENT_USER == 004
	if (RomSum != WHODUNNIT_ROMSUM)
		goto ErrorReturn;
#elif CURRENT_USER == 005
	if (RomSum != ROADSHOW_ROMSUM)
		goto ErrorReturn;
#endif

	Ptr = DocPtr->m_szDataBuffer.GetBuffer(Length);




	Data.ROMSize = Length;
	TotalPages = (unsigned char)((Length + (PAGE_LENGTH - 1)) / PAGE_LENGTH);

	Page = 
	Search1Hit = 
	Search2Hit = 
	Search1Found = 
	Search2Found = 
	TempUint = 0;
	TableAddressAddress = 0;
	
	for (i = 0; ((i < TotalPages) && (!Search1Found)); i++, Page++)
	{
		// 
		// We quit as soon as Search1 is found but we need to
		// check the entire ROM for Search2.  A ROM image with
		// Search1 definately has the pattern with the table,
		// but Search2 could exist in a Search1 ROM but even
		// after we find a Search2 match we need to keep checking 
		// for Search1.
		//
		for (j = 0; ((j < PAGE_LENGTH) && (!Search1Found)); j++)
		{
#if CURRENT_USER == 004
			if (RomXor != WHODUNNIT_ROMXOR)
				goto ErrorReturn;
#elif CURRENT_USER == 005
			if (RomXor != ROADSHOW_ROMXOR)
				goto ErrorReturn;
#endif
			switch ((*Ptr++) & 0xFF)
			{
				//
				// Search1: 30 8B 58 49 30 8B
				// Search2: 3A 3A 3A D6
				//

				case 0x3A :
					if (Search2Found)
						break;
					switch (Search2Hit)
					{
						case 0:
							Search2Hit++;
							break;
						case 1:
							Search2Hit++;
							break;
						case 2:
							Search2Hit++;
							break;
						default :
							Search2Hit = 0;
					}
					break;

				case 0xD6 :
					if (Search2Found)
						break;
					if (Search2Hit == 3)
					{
						//
						// First get the possible page byte
						//
						unsigned char ProcessThis = 0;
						TableAddressAddress = 0;
						LocalPtr = Ptr;
						if ((*(LocalPtr + 3) & 0xFF) == 0xC6)
							TablePageByte = (*(LocalPtr + 4) & 0xFF);
						else
							TablePageByte = ((((Page * PAGE_LENGTH) & 0xF0000) / PAGE_LENGTH) + 0x21);
						//
						// Next search for the various patterns..
						//
						LocalPtr -= 6;  // Now check for the 1F at 5th previous
						if (((*LocalPtr) & 0xFF) == 0x1F)
						{
							//
							// 0x1F was found at 5th previous byte, special
							// WhiteWater address.
							//
							TempUint = 0x844D;
							TablePageByte = 0x25;
							ProcessThis = 1;
						}
						if (!ProcessThis)
						{
							//
							// It wasn't 0x1F at 5th previous so check for
							// 8E (direct) or BE (referenced) at 8th previous.
							//
							LocalPtr -= 3;
							TempByte = ((*LocalPtr) & 0xFF);
							if ((TempByte == 0x8E) || (TempByte == 0xBE))
								ProcessThis = 2;
						}
						if (!ProcessThis)
						{
							//
							// Didn't find 8E or BE at 8th previous so now
							// check for 8E (direct) or BE (referenced) at
							// 12th previous.
							//
							LocalPtr -= 4;
							TempByte = ((*LocalPtr) & 0xFF);
							if ((TempByte == 0x8E) || (TempByte == 0xBE))
								ProcessThis = 2;
						}
						if (!ProcessThis)
						{
							//
							// Didn't find 8E or BE at 12th previous so now
							// check for 8E (direct) or BE (referenced) at 
							// 23rd previous.  There must also be a 8E at
							// the 06th previous byte for this...
							//
							LocalPtr -= 11;
							TempByte = ((*LocalPtr) & 0xFF);
							if (((TempByte == 0x8E) || (TempByte == 0xBE))
								&& (((*(LocalPtr + 17)) & 0xFF) == 0x8E)) 
								ProcessThis = 2;
						}
						if (!ProcessThis)
						{
							//
							// Didn't find 8E or BE at 23rd previous so now
							// check for 8E (direct) or BE (referenced) at
							// 06th previous.
							//
							LocalPtr += 17;
							TempByte = ((*LocalPtr) & 0xFF);
							if ((TempByte == 0x8E) || (TempByte == 0xBE))
							{
								if ((((*(LocalPtr - 8)) & 0xFF) == 0xEE) ||
									(((*(LocalPtr - 6)) & 0xFF) == 0xEE) ||
									(((*(LocalPtr - 7)) & 0xFF) == 0xBF))
									ProcessThis = 2;
							}
						}

						if (ProcessThis)
						{
							if (ProcessThis == 2)
							{
								LocalPtr++;
								TableAddressAddress = (*LocalPtr++) & 0xFF;
								TableAddressAddress <<= 8;
								TableAddressAddress |= (*LocalPtr) & 0xFF;
								TableAddressAddress &= 0xFFFF;
								if (TempByte == 0xBE)
								{
									LocalPtr = DocPtr->m_szDataBuffer.GetBuffer(Length);
//									TempByte = TablePageByte;
//									if (Data.ROMSize != 0x100000)
//									{
//										if (TempByte >= 0x20)
//											TempByte -= 0x20;
//									}
//
//									TableAddressAddress = ((--TablePageByte * (PAGE_LENGTH - REG_XORSUM) + XorSum) & 0xF0000) + TableAddressAddress;
									TableAddressAddress += ((Page * PAGE_LENGTH) & 0xF0000);
									TempUint = (LocalPtr[TableAddressAddress]) & 0xFF;
									TempUint <<= 8;
									TempUint |= (LocalPtr[TableAddressAddress+1]) & 0xFF;
									TempUint &= 0xFFFF;
								}
								else
									TempUint = TableAddressAddress;
							}
							Search2Found = 1;
						}
						Search2Hit = 0;
					}
					else
						Search2Hit = 0;
					break;

				case 0x58 :	
					if (Search1Found)
						break;
					if (Search1Hit == 2)	
						Search1Hit++;	
					else	
						Search1Hit = 0;	
					break;

				case 0x49 :	
					if (Search1Found)
						break;
					if (Search1Hit == 3)	
						Search1Hit++;	
					else	
						Search1Hit = 0;	
					break;

				case 0x30 : 
					if (Search1Found)
						break;
					if (!Search1Hit || (Search1Hit == 4))
						Search1Hit++;
					else
						Search1Hit = 0;	
					break;
				case 0x8B : 
					if (Search1Found)
						break;
					if ((Search1Hit == 5) || (Search1Hit == 1))
					{
						if (Search1Hit == 1)
							Search1Hit++;
						else
						{
							if (j > 8)
							{
								LocalPtr = Ptr - 8;
								TableAddressAddress = (*LocalPtr++) & 0xFF;
								TableAddressAddress <<= 8;
								TableAddressAddress |= (*LocalPtr) & 0xFF;
								TableAddressAddress &= 0xFFFF;
								TablePageByte = Page;
								Search1Found = 1;
							}
						}
					}
					else
						Search1Hit = 0;
					break;
				default :
					Search1Hit = Search2Hit = 0;
					break;
			}
		}
	}
	if ((!(Search1Found)) && (!(Search2Found))
#if CURRENT_USER == 004
		&& (RomSum != WHODUNNIT_ROMSUM)
#elif CURRENT_USER == 005
		&& (RomSum != ROADSHOW_ROMSUM)
#endif
		)
	{
		AfxMessageBox("Could not determine graphic table location.");
		return 0;
	}

	if ((Search1Found)
#if CURRENT_USER == 004
		&& (RomXor == WHODUNNIT_ROMXOR)
#elif CURRENT_USER == 005
		&& (RomXor == ROADSHOW_ROMXOR)
#endif
		)
	{
//		TableAddressAddress = ((--Search1Page * (PAGE_LENGTH - REG_XORSUM) + XorSum) & 0xF0000) + TableAddress;
//		TableAddressAddress = ((--Search1Page * (PAGE_LENGTH - REG_XORSUM) + XorSum) & 0xF0000) + TableAddressAddress;
		TableAddressAddress = ((--TablePageByte * (PAGE_LENGTH - REG_XORSUM) + XorSum) & 0xF0000) + TableAddressAddress;

		//
		// Now that we have the address of the graphic table address, look it up
		//
		Ptr = DocPtr->m_szDataBuffer.GetBuffer(Length);
		TempUint = (Ptr[TableAddressAddress]) & 0xFF;
		TempUint <<= 8;
		TempUint |= (Ptr[TableAddressAddress+1]) & 0xFF;
		TempUint &= 0xFFFF;
//		Data.TableAddress = TableAddress;
		TablePageByte = Ptr[TableAddressAddress+2] & (0xFF - REG_XOR) + XorValue;
	}

	if (Data.ROMSize == 0x100000)
	{
		Data.TableAddress = (TablePageByte * PAGE_LENGTH) 
			+ (TempUint - PAGE_LENGTH);
	}
	else
	{
		if (TablePageByte < 0x20)
		{
			Data.TableAddress = (TablePageByte * PAGE_LENGTH) 
				+ (TempUint - PAGE_LENGTH);
		}
		else
		{
			Data.TableAddress = ((TablePageByte - 0x20) * PAGE_LENGTH) 
				+ (TempUint - PAGE_LENGTH);
		}
	}
#if CURRENT_USER == 004
//	Data.TableAddress += 36;
#endif

//Data.TableAddress = 0x7E591; // The Addams Family L-6
//Data.TableAddress = 0x7E7E2; // The Addams Family L-5
//Data.TableAddress = 0x58001; // The Addams Family Gold H3
//Data.TableAddress = 0x7E5C1; // Black Rose
//Data.TableAddress = 0x24001; // Creature From the Black Lagoon
//Data.TableAddress = 0x0936a; // Dracula
//Data.TableAddress = 0x094BB; // Dr. Who
//Data.TableAddress = 0x2C88A; // Fish Tales
//Data.TableAddress = 0x3E45A; // Gilligans Island *** Unable to find table
//Data.TableAddress = 0x3C001; // High Speed II
//Data.TableAddress = 0x3DF43; // Hurricane  
//Data.TableAddress = 0x3DC66; // Slugfest *** Different encoding schemes, all garbaged except logo***
//Data.TableAddress = 0x       // Tales of the Arabian Nights
//Data.TableAddress = 0x08001; // Terminator 2 *** Different encoding schemes
//Data.TableAddress = 0x1844D;       // White Water


	Data.CurrentIndex = 0;

//	m_NextGraphic.SetFocus();
//	SetDefID(IDC_BUTTON_NEXT_GRAPHIC);
	DecodeImageCurrentIndex();

#endif
	return 1;
}


void DMD::DecodeImageCurrentIndex(void)
{
	DecodeImage(Data.CurrentIndex, 0);        // Decode to plane 0
	DecodeImage((Data.CurrentIndex + 1), 1);  // Decode to plane 1
	UpdateStaticTextBoxes();
}

void DMD::DecodeImage(int Index, int Plane)
{
//#if !SPECIAL_UNLOCK_BUILD
#ifndef UNLOCKBUILD
	const char *XorPtr = &RegisteredUser[REG_LENGTH];
	unsigned int ii = 0;
	unsigned int jj = strlen(RegisteredUser);
	unsigned char XorValue   = 0x00;
	unsigned char XorSum     = XOR_SEED;

	unsigned char *OriginalDataPtr;
	unsigned char *DataPtr;
	unsigned char *DataBuffer = &Data.Plane_0[0];
	unsigned char *SkippedBuffer = &Data.Plane_0Skipped[0];
	unsigned char *XoredBuffer = &Data.Plane_0Xored[0];
	unsigned char *PlaneStatusPtr = &Data.Plane_0Status;
	unsigned int  *SizePtr = &Data.Plane_0Size;
	unsigned char ImagePageByte;
	unsigned long ulong;
	unsigned long ImageEntry;
	unsigned int i;
	if (Plane)
	{
		DataBuffer = &Data.Plane_1[0];
		SkippedBuffer = &Data.Plane_1Skipped[0];
		XoredBuffer = &Data.Plane_1Xored[0];
		PlaneStatusPtr = &Data.Plane_1Status;
		SizePtr = &Data.Plane_1Size;
	}
	//
	// We'll clear out the page of data bytes here..
	//
	for (i = 0; i < DMD_PAGE_BYTES; i++)
	{
		DataBuffer[i] = SkippedBuffer[i] = XoredBuffer[i] = 0x00;
	}
	//
	// We'll assume the image will be valid unless one of these bits get set
	//
	*PlaneStatusPtr = PLANE_STATUS_VALID;

	// Each graphic table entry is 3 bytes long
	ImageEntry = (Index * 3) + Data.TableAddress;

	CHexEditorDoc *DocPtr = (((CHexEditorView *)((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView())->GetDocument());
	ASSERT_VALID(DocPtr);
	LPTSTR Ptr = DocPtr->m_szDataBuffer.GetBuffer(DocPtr->m_nBufferLength);

	if (ImageEntry >= Data.ROMSize)
	{
//		AfxMessageBox("Graphic Address is out of range, possible have reached end of graphic table");
		*PlaneStatusPtr = PLANE_STATUS_TABLEENTRYOUTOFRANGE;
		return;
	}

	int Confuse1,Confuse2,Confuse3;
	{
		int Confuse4;
		unsigned char TempByte;
		const char *Ptr;
		int Confuse5;
		unsigned int  i,j;
		unsigned char XorValue   = 0x00;
		int Confuse6;
		unsigned char XorSum     = MYXOR_SEED2;
		unsigned int  CheckSum   = 0x0000;
		Confuse1 = Confuse4 = j = strlen(MyInfo);
		for (Confuse2 = Confuse3 = i = 0, Confuse5 = Confuse6 = MY_XOR2,
			 Ptr = &MyInfo[0]; i < j; i++)
		{
			Confuse1 += (Confuse6 ^ j);
			TempByte = *Ptr++;
			Confuse5 ^= (TempByte + *(Ptr - 1));
			XorValue ^= TempByte;
			Confuse2 -= (Confuse3 - XorValue);
			XorSum   += XorValue;
			Confuse4 ^= (XorValue ^ XorSum);
			CheckSum += TempByte;
		}
		if (   (XorValue != MY_XOR2)
			|| (XorSum != MY_XORSUM2)
			|| (Confuse6 == Confuse1)
			|| ((CheckSum & 0xFFFF) != MY_CSUM)
			|| (j != MY_LENGTH)
			|| (Confuse2 == Confuse3)
			)
			return;
	}

	for (Confuse2 = Confuse3 = ii = 0, Confuse1 = REG_LENGTH,XorPtr-=REG_LENGTH;
	     ii < jj; ii++)
	{
		Confuse1 += (Confuse3 ^ ii);
		XorValue ^= *XorPtr++;
		XorSum   += XorValue;
		Confuse2 -= (Confuse1 ^ jj);
	}

	
	ulong = (Ptr[ImageEntry++]) & 0xFF;
	if (Confuse2 != Confuse1)
	ulong <<= 8;
	if (Confuse1 != Confuse3)
	ulong |= (Ptr[ImageEntry++]) & 0xFF;
	ulong &= 0xFFFF;

	ulong -= (PAGE_LENGTH + REG_XORSUM) - XorSum; // Subtract 0x4000 from the address
	ImagePageByte = Ptr[ImageEntry];
	if (Data.ROMSize == 0x100000)
	{
		ulong += (ImagePageByte * PAGE_LENGTH);
	}
	else if (Data.ROMSize == 0x80000)
	{
		if (ImagePageByte < 0x20)
		{
//			ulong += ((ImagePageByte + 0x20) * PAGE_LENGTH);
			ulong += (ImagePageByte * PAGE_LENGTH);
		}
		else
		{
			ulong += ((ImagePageByte - 0x20) * PAGE_LENGTH);
		}
	}
	else
		ulong += ((ImagePageByte & 0x0F) * PAGE_LENGTH);

	if (ulong >= Data.ROMSize)
	{
//		AfxMessageBox("Graphic Address is out of range, possibly have reached end of graphic table");
		*PlaneStatusPtr = PLANE_STATUS_IMAGEOUTOFRANGE;
		return;
	}


	long xor = ((REG_CSUM << 16) + (XorValue << 8) + (XorSum));
	unsigned char MD5[MD5_HASH_SIZE];
	unsigned char *MD5Ptr = MD5;
	Confuse1 ^= xor;
	xor ^= PassedInPointer->DiskId;
	Confuse3 ^= xor;

	*MD5Ptr++ = (xor >> 24) & 0xFF;
	*MD5Ptr++ = (xor >> 16) & 0xFF;
	*MD5Ptr++ = (xor >> 8) & 0xFF;
	*MD5Ptr   = (xor & 0xFF);
	Confuse1 = *MD5Ptr;
	Confuse2 = *(MD5Ptr - 1);
	Confuse3 = *(MD5Ptr - 2);
	((CHexEditorApp *)AfxGetApp())->CalculateMD5(MD5, 4, MD5);
	for (ii = 0; ii < 3; ii++)
	{
		Confuse3 += MD5[ii];
		Confuse2 += MD5[(ii + 1)];
		Confuse1 += MD5[(ii + 2)];
	}
	Confuse3 ^= XorValue;
	Confuse1 += Confuse3;
	DataPtr = (unsigned char *)&Ptr[(ulong + (REG_XOR - TRUE)
		
		+  (( (((MD5[0]) & 0xFF) << 24) +
	 	      (((MD5[1]) & 0xFF) << 16) +
		      (((MD5[2]) & 0xFF) << 8) +
		      ((MD5[3]) & 0xFF)
		    )
		      == PassedInPointer->UnlockKey)
		) - XorValue];
	
//CString Test;
//Test.Format("Graphic Entry %u address is %5.5X",Index,ulong);
//AfxMessageBox(Test);
	OriginalDataPtr = DataPtr;
//	*PlaneStatusPtr = DecodeImage(DataPtr, DataBuffer, SkippedBuffer, XoredBuffer);
	*PlaneStatusPtr = DecodeImage(&DataPtr, DataBuffer, SkippedBuffer, XoredBuffer);
	*SizePtr = (DataPtr - OriginalDataPtr) /*- 1*/;
#endif
}

unsigned char DMD::DecodeImage(unsigned char **Source, unsigned char *Dest, unsigned char *Skipped, unsigned char *Xored)
{
//	CString str;
//	unsigned char ch = *Source++;
	unsigned char ch = **Source;
	(*Source)++;
//ch &= 0x0F;
//ch = *Source++;
//ch = *Source++;
//	int i;
	//
	// We'll clear out the page of data bytes here..
	//
//	for (i = 0; i < DMD_PAGE_BYTES; i++)
//		Dest[i] = 0x00;

	//
	// At last, here we start the nitty gritty of decoding the images...
	//
	switch (ch)
	{
		case 0x00	:  //  Raw 32 bytes by 16 byes copy, no encodings.
			Decode_00(Source, Dest);
			break;
		case 0x01   :  //  Simple Repeats, Columns
			Decode_01(Source, Dest);
			break;
		case 0x02   :  //  Simple Repeats, Rows
			Decode_02(Source, Dest);
			break;
		case 0x03   :  //  <unsure>
			Decode_03(Source, Dest);
			return PLANE_STATUS_UNIMPLEMENTED_TYPE; // this is a cheat but we know that type 03 is not being decoded
//			break;
		case 0x04   :  //  Complex Repeats, 9-byte header, Columns
			Decode_04(Source, Dest);
			break;
		case 0x05   :  //  Complex Repeats, 9-byte header, Rows
			Decode_05(Source, Dest);
			break;
		case 0x06   :  //  XOR-Repeat, Columns
			Decode_06(Source, Dest, Xored);
			break;
		case 0x07   :  //  XOR-Repeat, Rows
			Decode_07(Source, Dest, Xored);
			break;
		case 0x08   :  //  Bulk Skips and Bulk Repeats, Columns
			Decode_08(Source, Dest, Skipped);
			break;
		case 0x09   :  //  Bulk Skips and Bulk Repeats, Rows
			Decode_09(Source, Dest, Skipped);
			break;
		case 0x0A   :  //  Write Data Bytes or Multiple Skips, Columns
			Decode_0A(Source, Dest, Skipped);
			break;
		case 0x0B   :  //  Write Data Bytes or Multiple Skips, Rows
			Decode_0B(Source, Dest, Skipped);
			break;
		default	:
//			str.Format("Unknown Image Type 0x%2.2X",ch);
//			AfxMessageBox(str);
//DecodeImage(Source, Dest, Skipped, Xored);
//			break;
			return PLANE_STATUS_UNKNOWN_TYPE;
	}
	return PLANE_STATUS_VALID;
}

//  Raw 32 bytes by 16 byes copy, no encodings.
//void DMD::Decode_00(unsigned char *Source, unsigned char *Dest)
void DMD::Decode_00(unsigned char **Source, unsigned char *Dest)
{
	int i;
	for (i = 0; i < DMD_PAGE_BYTES; i++)
//		*Dest++ = *Source++;
	{
		*Dest++ = **Source;
		(*Source)++;
	}
}

//  Simple Repeats, Columns
//void DMD::Decode_01(unsigned char *Source, unsigned char *Dest)
void DMD::Decode_01(unsigned char **Source, unsigned char *Dest)
{
// IMAGE TYPE 0x04 or 0x01                ; EDF1h   Byte1 = Byte AFTER the 0x04
//
// Simple Repeats, Columns
//
// Format:
//  0x02                   Image type byte, byte that got us this far.
//   <Special Flag Byte>   Special 8-bit value that is used to signal repeats
//   <data starts here>
//
// This is a simple encoding very similar to IMAGE TYPE 0x05 or 0x02.  This
// encoding uses a simple single-special-byte at the top and whenever this
// byte is encountered, the following 2 bytes are used for Repeat/Data so that
// the Data is repeated for the number of times in 'Repeat'.
//
// The only difference between this and IMAGE TYPE 0x05 or 0x02 is that this
// encoding method writes in columns from LEFT to RIGHT starting at the top
// left and ending at the bottom right of the DMD.
//
//	Decode_01or02(&Source,&Dest,WRITE_TYPE_COLUMNS);
	Decode_01or02(Source,&Dest,WRITE_TYPE_COLUMNS);
}

//void DMD::Decode_02(unsigned char *Source, unsigned char *Dest)
void DMD::Decode_02(unsigned char **Source, unsigned char *Dest)
{
// IMAGE TYPE 0x05 or 0x02                ; EE70h
//
// Simple Repeats, Rows
//
// Format:
//  0x02                   Image type byte, byte that got us this far.
//   <Special Flag Byte>   Special 8-bit value that is used to signal repeats
//   <data starts here>
//
// This is a very basic encoding that allows for repeats 8-bit patterns that
// might occur frequently.  This writes the DMD from the TOP to the BOTTOM,
// starting at the top left and ending at the bottom right.  As with all
// encodings, the data actually appears in reverse at every 8-bit column on the
// DMD, for example if the first 2 data bytes are A0B0, the top row, left side
// of the DMD will illuminate the pixels like: .....0.0 ....00.0
// (0 is on pixel, . is off pixel)
//
// The bytes are read from the data and written to the DMD memory (again, in
// ROWS on the DMD from top to bottom).  When a byte is found that matches the
// byte defined as <Special Flag Byte> then instead of writing the byte to the
// DMD, the following 2 bytes are read, making up the following format:
//
// <Special Flag Byte> <Length> <Pattern>
//
// The 8-bits defined in <Pattern> are written to the DMD for the number of times
// defined in <Length>.
//
// If the actual byte defined in <Special Flag Byte> needs to be drawn on the DMD
// then a <Length> byte of 1 can be used with the <Pattern> byte matching the
// <Special Flag Byte>.  The length should not be 0, if the length is zero, then
// the pattern will end up being repeated 256 times.
//
//	Decode_01or02(&Source,&Dest,WRITE_TYPE_ROWS);
	Decode_01or02(Source,&Dest,WRITE_TYPE_ROWS);
}


void DMD::Decode_01or02(unsigned char **SourcePtr, unsigned char **DestPtr, unsigned char Type)
{
	unsigned char ch;
	unsigned char SpecialFlagByte;
	unsigned int WriteCounter;

	SpecialFlagByte = **SourcePtr;
	(*SourcePtr)++;
	WriteCounter = 0;         // Stores bytes we've written to DMD Ram
	do
	{
		ch = **SourcePtr;
		(*SourcePtr)++;
		if (ch == SpecialFlagByte)
		{
			unsigned char Value1 = **SourcePtr;
			(*SourcePtr)++;
			unsigned int Value2 = **SourcePtr;
			(*SourcePtr)++;
			do
			{
				WriteNext8BitValue(DestPtr,&WriteCounter, Value2, Type);
			} while ((--Value1) && (WriteCounter < DMD_PAGE_BYTES));
		}
		else
			WriteNext8BitValue(DestPtr,&WriteCounter, ch, Type);
	} while (WriteCounter < DMD_PAGE_BYTES);
}

//  <unsure>
//void DMD::Decode_03(unsigned char *Source, unsigned char *Dest)
void DMD::Decode_03(unsigned char **Source, unsigned char *Dest)
{
//	AfxMessageBox("Image type 03 not implemented");
}

//void DMD::Decode_04(unsigned char *Source, unsigned char *Dest)
void DMD::Decode_04(unsigned char **Source, unsigned char *Dest)
{
//  IMAGE TYPE 0x07 or 0x04      ; Byte1 = byte AFTER bitmap type
//
// Complex Repeats, 9-byte header, Columns
//
// Format:
//  0x04                   Image type byte, byte that got us this far.
//   <Special Flag Byte>   Special 8-bit value that is used to signal special encodings.
//   <Special Byte 1>      Special #1  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 2>      Special #2  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 3>      Special #3  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 4>      Special #4  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 5>      Special #5  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 6>      Special #6  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 7>      Special #7  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 8>      Special #8  Can be used for repeat counts or for actual bitmap data.
//    <data starts here>
//
//   All bits drawn on the dot matrix display for this image type are drawn
//   in COLUMNS starting at the top of the left most 8-bit column and ending
//   at the bottom of the right-most 8-bit column.  It should be noted that the
//   bits are also mirror-reversed for every of the 16 8-bit columns.  For
//   example when the first byte of display memory contains a value of 0xC0 the
//   top left corner of the dot matrix display will show ......OO where 'O' is
//   an illuminated pixel and '.' is an off pixel.
//
//   Data Format:  Continuous stream of bits, starting at 0x80 bit of the first
//                 byte and continuing until all 32x128 dots are accounted for.
//                 This continuous stream of bits opeates in the following
//                 manner...
//
//   When '0' bit is encountered, the following 8 bits are drawn on the dot
//   matrix directly (no special encoding).  When '1' extension bit is
//   encountered, the number of continuous 1s that follow is counted up
//   (until a zero trailing bit is encountered and consumed).  Note that the
//   maximum number of continuous 1s to follow the extension bit is 7, this
//   means there is NO trailing 0 bit that is consumed after 7 continuous 1s.
//   After 7 continuous 1s after the extension bit, the next command is
//   processed (ie if 0 then draw next 8 bits, if 1 process another extension
//   bit set).  The number of continuous 1s that follow the extension bit
//   cause the following to occur...
//
//   # of 1s following extension bit                    Effect
//   ----------------------------------------------------------------------------
//                0                      Draw 8 bits defined in <Special Byte 1>, or special repeat encoding, see below,
//                1                      Draw 8 bits defined in <Special Byte 2>, or special repeat encoding, see below,
//                2                      Draw 8 bits defined in <Special Byte 3>, or special repeat encoding, see below,
//                3                      Draw 8 bits defined in <Special Byte 4>, or special repeat encoding, see below,
//                4                      Draw 8 bits defined in <Special Byte 5>, or special repeat encoding, see below,
//                5                      Draw 8 bits defined in <Special Byte 6>, or special repeat encoding, see below,
//                6                      Draw 8 bits defined in <Special Byte 7>, or special repeat encoding, see below,
//                7                      Draw 8 bits defined in <Special Byte 8>, or special repeat encoding, see below,
//
//   <special repeat encoding>
//   If the <Special Byte X> byte matches the 8-bit value <Special Flag Byte>
//   (at top of graphic header) then those 8-bits defined in the special byte
//   will NOT be drawn, instead the bit stream is read for the next TWO VALUES.
//   The next two values that are pulled from the bit stream can be encoded by
//   referencing the Special Byte (using extension bit followed by appropriate
//   number of continuous 1s) or the next two values can be pulled from the bit
//   stream using non-extended method (a 0-bit followed by 8 bits representing
//   the value.  The next 2 values that are pulled from the bit stream can also
//   be encoded using any combination of the previously mentioned encoded
//   methods.  Typically the first of the 2 values is encoded using the
//   extension-bit method and usually the 2nd of the 2 values is also encoded
//   using the extension bit method, although it is not uncommon to see the
//   2nd of the 2 values be a direct encoded value (0 bit followed by the
//   desired 8-bit value.
//
//   The next 2 values that follow are used in the following manner:
//     <Value1>  This is the first value read after the Special Flag Byte match occurs.
//     <Value2>  This is the second value read after the Special Flag Byte match occurs.
//
//   The 8-bit value defined by <Value2> is repeated for the number of times
//   defined by <Value1>.
//
//
//struct ImageHeader
//{
//	unsigned char SpecialFlagByte;
//	unsigned char RepeatBytes[8];
//	unsigned char ReadMask;
//};
//AfxMessageBox("Decoding type 04");
//	Decode_04or05(&Source, &Dest, WRITE_TYPE_COLUMNS);
	Decode_04or05(Source, &Dest, WRITE_TYPE_COLUMNS);
}

//void DMD::Decode_05(unsigned char *Source, unsigned char *Dest)
void DMD::Decode_05(unsigned char **Source, unsigned char *Dest)
{
// Complex Repeats, 9-byte header, Rows
//
// Format:
//  0x04                   Image type byte, byte that got us this far.
//   <Special Flag Byte>   Special 8-bit value that is used to signal special encodings.
//   <Special Byte 1>      Special #1  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 2>      Special #2  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 3>      Special #3  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 4>      Special #4  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 5>      Special #5  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 6>      Special #6  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 7>      Special #7  Can be used for repeat counts or for actual bitmap data.
//   <Special Byte 8>      Special #8  Can be used for repeat counts or for actual bitmap data.
//    <data starts here>
//
// This is exactly the same as IMAGE TYPE 0x07 or 0x04 except data is written
// on the DMD ram in ROWS from top-left to bottom-right.  This takes less code
// space because there is no special code to decrement DMD ram to get the pointer
// to the top of the next column.  See image type 0x07 or 0x04 below for details.
//
//	Decode_04or05(&Source, &Dest, WRITE_TYPE_ROWS);
//	AfxMessageBox("Type 05", MB_OK);
	Decode_04or05(Source, &Dest, WRITE_TYPE_ROWS);
}

void DMD::Decode_04or05(unsigned char **SourcePtr, unsigned char **DestPtr, unsigned char Type)
{
	ImageHeader Header;
	unsigned char ch;
	int i;
	unsigned int WriteCounter;

//	AfxMessageBox(" type 0x05 needs work, not always decoding properly", MB_OK);

	Header.ReadMask = 0x80;
	WriteCounter = 0;         // Stores bytes we've written to DMD Ram

	Header.SpecialFlagByte = **SourcePtr;
	(*SourcePtr)++;
	for (i = 0; i < 8; i++)
	{
		Header.RepeatBytes[i] = **SourcePtr;
		(*SourcePtr)++;
	}

	do
	{
		ch = ReadNext8BitValue(&Header,SourcePtr);
		if (ch == Header.SpecialFlagByte)
		{
			unsigned char Value1 = ReadNext8BitValue(&Header,SourcePtr);
			unsigned int Value2 = (unsigned int)ReadNext8BitValue(&Header,SourcePtr);
			do
			{
//				WriteNext8BitValue(DestPtr,&WriteCounter, Value2, WRITE_TYPE_COLUMNS);
				WriteNext8BitValue(DestPtr,&WriteCounter, Value2, Type);
			} while ((--Value1) && (WriteCounter < DMD_PAGE_BYTES));
		}
		else
//			WriteNext8BitValue(DestPtr,&WriteCounter, ch, WRITE_TYPE_COLUMNS);
			WriteNext8BitValue(DestPtr,&WriteCounter, ch, Type);
	} while (WriteCounter < DMD_PAGE_BYTES);
	if (Header.ReadMask == 0x80)
		(*SourcePtr)--;
}

void DMD::WriteNext8BitValue(unsigned char **DestPtr, unsigned int *WriteCounterPtr, unsigned char ch, unsigned char Type)
{
	(**DestPtr) = ch;      // Write the actual 8-bit value
	if (((*WriteCounterPtr)++) >= DMD_PAGE_BYTES)
		return;

	if (Type == WRITE_TYPE_ROWS)
	{
		(*DestPtr)++;
		return;
	}
	if (!((*WriteCounterPtr) % DMD_ROWS))
	{
		// 
		// We just finished writing 32 bytes for a particular column.
		// We need to Adjust the write pointer to point up to the top
		// of the next column over.
		//
		(*DestPtr) -= (((DMD_COLUMNS/8) * (DMD_ROWS - 2)) + ((DMD_COLUMNS/8) - 1));
	}
	else
	{
		//
		// We just finished writing some byte within the 32-byte column
		// NOT the last row of the column, so just advance to next row down
		// within this column.
		//
		(*DestPtr) += (DMD_COLUMNS/8);
	}
}

unsigned char DMD::ReadNext8BitValue(struct ImageHeader *Header, unsigned char **SourcePtr)
{
	unsigned char ch = ReadNextBit(Header, SourcePtr);
	unsigned char WriteMask;
	unsigned char ReturnValue;
	int i;

	if (ch)
	{
		int OnesCount = 0;
		for (i = 0; i < 7; i++) // at most 7 one-bits to follow
		{
			if (ReadNextBit(Header, SourcePtr))
				OnesCount++;
			else
				i = 7;
		}
		ReturnValue = Header->RepeatBytes[OnesCount];
	}
	else
	{
		// 
		// Read the next 8 bits and return the value.
		//
		WriteMask = 0x80;
		ReturnValue = 0x00;
		for (i = 0; i < 8; i++)
		{
			if (ReadNextBit(Header, SourcePtr))
				ReturnValue |= WriteMask;
			WriteMask >>= 1;
		}
	}
	return (ReturnValue);
}

unsigned char DMD::ReadNextBit(struct ImageHeader *Header, unsigned char **SourcePtr)
{
	unsigned char ch = (**SourcePtr & Header->ReadMask);
	if (!(Header->ReadMask >>= 1))
	{
		Header->ReadMask = 0x80;
		(*SourcePtr)++;
	}
	return ch;
}


//void DMD::Decode_06(unsigned char *Source, unsigned char *Dest, unsigned char *Xored)
void DMD::Decode_06(unsigned char **Source, unsigned char *Dest, unsigned char *Xored)
{
// IMAGE TYPE 0x09 or 0x06                ; ECE6h
//
// XOR-Repeat, Columns
//
// Format:
//  0x02                   Image type byte, byte that got us this far.
//   <Special Flag Byte>   Special 8-bit value that is used to signal repeats
//   <data starts here>
//
// This encoding is identical to IMAGE TYPE 0x0A or 0x07 except the data is
// drawn to DMD ram in COLUMNS from LEFT to RIGHT starting at the top left of
// the DMD and ending at the bottom right.
//
//	Decode_06or07(&Source, &Dest, &Xored, WRITE_TYPE_COLUMNS);
	Decode_06or07(Source, &Dest, &Xored, WRITE_TYPE_COLUMNS);
}

//void DMD::Decode_07(unsigned char *Source, unsigned char *Dest, unsigned char *Xored)
void DMD::Decode_07(unsigned char **Source, unsigned char *Dest, unsigned char *Xored)
{
// IMAGE TYPE 0x0A or 0x07                ; ED80h
//
// XOR-Repeat, Rows
//
// Format:
//  0x02                   Image type byte, byte that got us this far.
//   <Special Flag Byte>   Special 8-bit value that is used to signal repeats
//   <data starts here>
//
// Special XOR encoding.  This encoding scheme writes to the DMD in ROWS from
// the TOP to BOTTOM of the DMD starting at the top-left and ending at the
// bottom right of the display.
//
// Each byte is read from the data.  If a byte doesn't match the <Special Flag
// Byte> (first byte) then the byte is simply drawn to the DMD ram.  As with all
// encoding schemes the image for each of the 16 colums is actually drawn in
// reverse as it appears in ram.
//
// If the next data byte that is read DOES match the <Special Flag Byte> then
// the next 2 bytes are read, this makes a 3-byte pattern in the following
// manner:
//
//  <Special Flag Byte>  <Repeat Count>  <XOR Value>
//
// When the <Special Flag Byte> is encountered, then the next 2 bytes represent
// the <Repeat Count> and <XOR Value>.  The XOR Value is applied to the
// EXISTING DMD ram for the number of bytes defined in <Repeat Count>.  That is,
// the existing data in the RAM is XORed with the <XOR Value> for the number of
// bytes in <Repeat Count>.
//
//	Decode_06or07(&Source, &Dest, &Xored, WRITE_TYPE_ROWS);
	Decode_06or07(Source, &Dest, &Xored, WRITE_TYPE_ROWS);
}

void DMD::Decode_06or07(unsigned char **SourcePtr, unsigned char **DestPtr, unsigned char **XoredPtr, unsigned char Type)
{
	unsigned char ch;
	unsigned char SpecialFlagByte;
	unsigned int WriteCounter;
	unsigned int XoredCounter;

	SpecialFlagByte = **SourcePtr;
	(*SourcePtr)++;
	WriteCounter = XoredCounter = 0;         // Stores bytes we've written to DMD Ram
	do
	{
		ch = **SourcePtr;
		(*SourcePtr)++;
		if (ch == SpecialFlagByte)
		{
			unsigned char Value1 = **SourcePtr;
			(*SourcePtr)++;
			unsigned int Value2 = **SourcePtr;
			(*SourcePtr)++;
			do
			{
				WriteNext8BitValue(DestPtr,&WriteCounter, 0x00, Type);
				WriteNext8BitValue(XoredPtr,&XoredCounter, Value2, Type);
			} while ((--Value1) && (WriteCounter < DMD_PAGE_BYTES));
		}
		else
		{
			WriteNext8BitValue(DestPtr,&WriteCounter, ch, Type);
			WriteNext8BitValue(XoredPtr,&XoredCounter,0x00,Type);
		}
	} while (WriteCounter < DMD_PAGE_BYTES);
}

//void DMD::Decode_08(unsigned char *Source, unsigned char *Dest, unsigned char *Skipped)
void DMD::Decode_08(unsigned char **Source, unsigned char *Dest, unsigned char *Skipped)
{
// IMAGE TYPE 0x0B or 0x08                ; EC91h
//
// Bulk Skips and Bulk Repeats, Columns
//
// Format:
//  Stream of Bytes:
//   <StartWithDataRepeatFlag>
//              |
//              |       Start Value is zero-->
//              +----------------------------------------\
//              |                                        |
//              |                                        |
//     <NonZeroRepeatPattern> [RepeatThePattern] --> <SkipCount> --> [PerformBulkSkip]
//              |                                                          |
//              |                                           <-- when done  |
//              \----------------------------------------------------------/
//
// This is identical to IMAGE TYPE 0x0C or 0x09 except data is drawn to DMD ram
// in COLUMNS left to right.
//
// This encoding scheme is a sequential reading of the data bytes and cycle of
// repeated data or row-per-column skipping.  This starts out reading the
// very first byte of the data and if it is zero, the loop starts at the right
// side of the diagram above at <SkipCount>.  If the first byte is non-zero then
// the loop starts at the left side of the diagram above at
// <NonZeroRepeatPattern>.
//
// When processing <NonZeroRepeatPattern>, if the byte is non-zero then the
// subsequent byte is read and repeated for the number of times defined in the
// previously read byte <NonZeroRepeatPattern>.  After doing this pattern
// repeat, the <SkipCount> byte is read.  The 8-bit rows-per-column are skipped
// for the number of times defined in <SkipCount>.  After skipping 8-bit rows
// in the column (or across multiple columns), the loop goes back to evaluate
// <NonZeroRepeatPattern> and this cycle continues until the entire DMD ram has
// been filled.  Note the <SkipCount> value can be zero, this will cause no
// skipping to occur and immediate wrap around to <NonZeroRepeatPattern>.
//
// As with all encoding schemes, the data appears on the DMD in reverse, for
// each column as it is stored in ram.  This is for each of the 16 columns.
//
//
// *** It appears the above write-up is incorrect, the left half does NOT
// *** repeat the pattern, rather it is the count of the number of data bytes
// *** to read from the source and then write to DMD ram, not repeat.
//
//	Decode_08or09(&Source, &Dest, &Skipped, WRITE_TYPE_COLUMNS);
	Decode_08or09(Source, &Dest, &Skipped, WRITE_TYPE_COLUMNS);
}

//void DMD::Decode_09(unsigned char *Source, unsigned char *Dest, unsigned char *Skipped)
void DMD::Decode_09(unsigned char **Source, unsigned char *Dest, unsigned char *Skipped)
{
// IMAGE TYPE 0x0C or 0x09                ; EBFEh
//
// Bulk Skips and Bulk Repeats, Rows
//
// Format:
//  Stream of Bytes:
//   <StartWithDataRepeatFlag>
//              |
//              |       Start Value is zero-->
//              +----------------------------------------\
//              |                                        |
//              |                                        |
//     <NonZeroRepeatPattern> [RepeatThePattern] --> <SkipCount> --> [PerformBulkSkip]
//              |                                                          |
//              |                                           <-- when done  |
//              \----------------------------------------------------------/
//
// This is identical to IMAGE TYPE 0x0B or 0x08 except data is drawn to DMD ram
// in ROWS top to bottom.
//
// This encoding scheme is a sequential reading of the data bytes and cycle of
// repeated data or 8-bit skipping.  This starts out reading the very first byte
// of the data and if it is zero, the loop starts at the right side of the
// diagram above at <SkipCount>.  If the first byte is non-zero then the loop
// starts at the left side of the diagram above at <NonZeroRepeatPattern>.
//
// When processing <NonZeroRepeatPattern>, if the byte is non-zero then the
// subsequent byte is read and repeated for the number of times defined in the
// previously read byte <NonZeroRepeatPattern>.  After doing this pattern
// repeat, the <SkipCount> byte is read.  Then 8-bits are skipped for the number
// of times defined in <SkipCount>.  After repeatably skipping 8-bits the loop
// goes back to evaluate <NonZeroRepeatPattern> and this cycle continues until
// the entire DMD ram has been filled.  Note the <SkipCount> value can be zero,
// this will cause no skipping to occur and immediate wrap around to
// <NonZeroRepeatPattern>.
//
// As with all encoding schemes, the data appears on the DMD in reverse, for
// each column as it is stored in ram.  This is for each of the 16 columns.
//
// *** It appears the above write-up is incorrect, the left half does NOT
// *** repeat the pattern, rather it is the count of the number of data bytes
// *** to read from the source and then write to DMD ram, not repeat.
//
//	Decode_08or09(&Source, &Dest, &Skipped, WRITE_TYPE_ROWS);
	Decode_08or09(Source, &Dest, &Skipped, WRITE_TYPE_ROWS);
}

void DMD::Decode_08or09(unsigned char **SourcePtr, unsigned char **DestPtr, unsigned char **SkippedPtr, unsigned char Type)
{
	unsigned char count;
	unsigned char pattern;
	unsigned int WriteCounter;
	unsigned int SkippedCounter;
//	AfxMessageBox("0809This image includes SKIPPING pixels, at this time skipped pixels are drawn as OFF pixels.");

	count = **SourcePtr;
	(*SourcePtr)++;
	WriteCounter = SkippedCounter = 0;         // Stores bytes we've written to DMD Ram
	if (!count)
		goto RepeatSkips;
	while (1)
	{
		count = **SourcePtr;
		(*SourcePtr)++;
		if (count)
		{
			do
			{
				pattern = **SourcePtr;
				(*SourcePtr)++;
				WriteNext8BitValue(DestPtr,&WriteCounter, pattern, Type);
				WriteNext8BitValue(SkippedPtr,&SkippedCounter, 0x00, Type);
			}
			while ((--count) && (WriteCounter < DMD_PAGE_BYTES));
		}
		if (WriteCounter >= DMD_PAGE_BYTES)
			break;
RepeatSkips:
		count = **SourcePtr;
		(*SourcePtr)++;
		if (count)
		{
			do
			{
				WriteNext8BitValue(DestPtr,&WriteCounter, 0x00, Type);
				WriteNext8BitValue(SkippedPtr,&SkippedCounter,0xFF, Type);
			}
			while ((--count) && (WriteCounter < DMD_PAGE_BYTES));
		}
		if (WriteCounter >= DMD_PAGE_BYTES)
			break;
	}
}

//void DMD::Decode_0A(unsigned char *Source, unsigned char *Dest, unsigned char *Skipped)
void DMD::Decode_0A(unsigned char **Source, unsigned char *Dest, unsigned char *Skipped)
{
// IMAGE TYPE 0x0D or 0x0A                ; EBFEh
//
// Write Data Bytes or Multiple Skips, Columns
//
// Format:
//  0x04                   Image type byte, byte that got us this far.
//   <Special Byte 1>      Special #1  Can be used for bitmap data.
//   <Special Byte 2>      Special #2  Can be used for bitmap data.
//   <Special Byte 3>      Special #3  Can be used for bitmap data.
//   <Special Byte 4>      Special #4  Can be used for bitmap data.
//   <Special Byte 5>      Special #5  Can be used for bitmap data.
//   <Special Byte 6>      Special #6  Can be used for bitmap data.
//   <Special Byte 7>      Special #7  Can be used for bitmap data.
//   <Special Byte 8>      Special #8  Can be used for bitmap data.
//    <data starts here>
//
//   Data Format (following the 8-byte header)
//   -----------------------------------------
//   <StartWithDataRepeatFlag>
//              |
//              |       Start Value is zero-->
//              +---------------------------------\
//              |                                 |
//              |                                 |
//        <DataLoadCount> [LoadDtaBytes] --> <SkipCount> --> [PerformBulkSkip]
//              |                                                    |
//              |                                     <-- when done  |
//              \----------------------------------------------------/
//
// This encoding scheme is identical to IMAGE TYPE 0x0E or 0x0B except this
// scheme writes the data on the DMD ram in COLUMNS.
//
// This encoding scheme first starts with the 8-byte header.  This is used by the
// F322 function call which will read the data as a continuous bit-stream
// starting at the 0x80 bit of the first byte and continuously working until the
// DMD ram has been filled.  The F322 function checks for the 1 extension bit
// to be set and if it is then the 8-byte header is used to index a particular
// 8-bit pattern that should be used.  If the index bit is zero, the F322
// function simply returns the 8-bits following the 0 non-extension bit.
//
// The data is written to the DMD ram in rows from LEFT to RIGHT.
//
// The diagram above shows the sequence of events, the very first data byte
// (after the 8-byte header) is used to determine of the cycle should begin
// at the right side <SkipCount> or the left side <DataLoadCount>.
//
// While processing through the loop, the <DataLoadCount> value indicates the
// number of 8-bit values that should be drawn to the DMD ram.  The number F322
// function is called for the number of times defined in <DataLoadCount>.  If
// this value is zero there is no bytes to load and the <SkipCount> is checked
// next.
//
// While processing through the loop, the <SkipCount> value indicates the number
// of 8-bit bytes that should be skipped in the DMD ram.  If this value is zero
// then there is no skipping and the following byte is read as the
// <DataLoadCount> value.
//
//	Decode_0Aor0B(&Source, &Dest, &Skipped, WRITE_TYPE_COLUMNS);
	Decode_0Aor0B(Source, &Dest, &Skipped, WRITE_TYPE_COLUMNS);
}

//void DMD::Decode_0B(unsigned char *Source, unsigned char *Dest, unsigned char *Skipped)
void DMD::Decode_0B(unsigned char **Source, unsigned char *Dest, unsigned char *Skipped)
{
// IMAGE TYPE 0x0E or 0x0B                ; EBC6h
//
// Write Data Bytes or Multiple Skips, Rows
//
// Format:
//  0x04                   Image type byte, byte that got us this far.
//   <Special Byte 1>      Special #1  Can be used for bitmap data.
//   <Special Byte 2>      Special #2  Can be used for bitmap data.
//   <Special Byte 3>      Special #3  Can be used for bitmap data.
//   <Special Byte 4>      Special #4  Can be used for bitmap data.
//   <Special Byte 5>      Special #5  Can be used for bitmap data.
//   <Special Byte 6>      Special #6  Can be used for bitmap data.
//   <Special Byte 7>      Special #7  Can be used for bitmap data.
//   <Special Byte 8>      Special #8  Can be used for bitmap data.
//    <data starts here>
//
//   Data Format (following the 8-byte header)
//   -----------------------------------------
//   <StartWithDataRepeatFlag>
//              |
//              |       Start Value is zero-->
//              +---------------------------------\
//              |                                 |
//              |                                 |
//        <DataLoadCount> [LoadDtaBytes] --> <SkipCount> --> [PerformBulkSkip]
//              |                                                    |
//              |                                     <-- when done  |
//              \----------------------------------------------------/
//
// This encoding scheme is identical to IMAGE TYPE 0x0D or 0x0A except this
// scheme writes the data on the DMD ram in ROWS.
//
// This encoding scheme first starts with the 8-byte header.  This is used by the
// F322 function call which will read the data as a continuous bit-stream
// starting at the 0x80 bit of the first byte and continuously working until the
// DMD ram has been filled.  The F322 function checks for the 1 extension bit
// to be set and if it is then the 8-byte header is used to index a particular
// 8-bit pattern that should be used.  If the index bit is zero, the F322
// function simply returns the 8-bits following the 0 non-extension bit.
//
// The data is written to the DMD ram in columns from TOP to BOTTOM.
//
// The diagram above shows the sequence of events, the very first data byte
// (after the 8-byte header) is used to determine of the cycle should begin
// at the right side <SkipCount> or the left side <DataLoadCount>.
//
// While processing through the loop, the <DataLoadCount> value indicates the
// number of 8-bit values that should be drawn to the DMD ram.  The number F322
// function is called for the number of times defined in <DataLoadCount>.  If
// this value is zero there is no bytes to load and the <SkipCount> is checked
// next.
//
// While processing through the loop, the <SkipCount> value indicates the number
// of 8-bit bytes that should be skipped in the DMD ram.  If this value is zero
// then there is no skipping and the following byte is read as the
// <DataLoadCount> value.
//
//	Decode_0Aor0B(&Source, &Dest, &Skipped, WRITE_TYPE_ROWS);
	Decode_0Aor0B(Source, &Dest, &Skipped, WRITE_TYPE_ROWS);
}

void DMD::Decode_0Aor0B(unsigned char **SourcePtr, unsigned char **DestPtr, unsigned char **SkippedPtr, unsigned char Type)
{
	ImageHeader Header;
	unsigned char count;
	int i;
	unsigned int WriteCounter;
	unsigned int SkippedCounter;
//	AfxMessageBox("0A0BThis image includes SKIPPING pixels, at this time skipped pixels are drawn as OFF pixels.");

	Header.ReadMask = 0x80;
	WriteCounter = SkippedCounter = 0;         // Stores bytes we've written to DMD Ram

	for (i = 0; i < 8; i++)
	{
		Header.RepeatBytes[i] = **SourcePtr;
		(*SourcePtr)++;
	}
	count = ReadNext8BitValue(&Header,SourcePtr);
	if (!count)
		goto BulkSkips;
	while (1)
	{
		count = ReadNext8BitValue(&Header,SourcePtr);
		if (count)
		{
			do
			{
				WriteNext8BitValue(DestPtr,&WriteCounter, (ReadNext8BitValue(&Header,SourcePtr)), Type);
				WriteNext8BitValue(SkippedPtr,&SkippedCounter, 0x00, Type);
			} while ((--count) && (WriteCounter < DMD_PAGE_BYTES));
		}
		if (WriteCounter >= DMD_PAGE_BYTES)
			break;
BulkSkips:
		count = ReadNext8BitValue(&Header,SourcePtr);
		if (count)
		{
			do
			{
				WriteNext8BitValue(DestPtr,&WriteCounter, 0x00, Type);
				WriteNext8BitValue(SkippedPtr,&SkippedCounter, 0xFF, Type);
			}
			while ((--count) && (WriteCounter < DMD_PAGE_BYTES));
		}
		if (WriteCounter >= DMD_PAGE_BYTES)
			break;
	} 
	if (Header.ReadMask == 0x80)
		(*SourcePtr)--;
}

void DMD::OnButtonNextGraphic() 
{
	// TODO: Add your control notification handler code here
#if ALLOW_MOUSE_TO_REPEAT
	int i = 0;
	if (NextDebounceState == DEBOUNCE_STATE_DONE)
		i++;
	NextDebounceState = DEBOUNCE_STATE_IDLE;
	NextDebounce = 0;
	if (i)
		return;
#endif

	if (!NaggedOnce)
	{
		if (!(PassedInPointer->MiscNagsShown[NAG_INDEX_DMD_ENTERKEY_TIP]))
		{
			unsigned char TheCheckBox = FALSE;
			NagDlg Nag(this, "Tip", (char *)&NagTexts[NAG_INDEX_DMD_ENTERKEY_TIP][0], &TheCheckBox);
			Nag.DoModal();
			if (TheCheckBox)
			{
				PassedInPointer->MiscNagsShown[NAG_INDEX_DMD_ENTERKEY_TIP] = TRUE;
				AfxGetApp()->WriteProfileInt(REGISTRY_NAG_SCREENS, NagRegistryKeyText[NAG_INDEX_DMD_ENTERKEY_TIP], TRUE);
			}
		}
	}
	NaggedOnce = 1;

//	if (Data.CurrentIndex < MAX_GRAPHIC_INDEX)
		Data.CurrentIndex++;
	DecodeImageCurrentIndex();
	InvalidateDMDPages();
	UpdateControls();
}

void DMD::OnButtonPreviousGraphic() 
{
	// TODO: Add your control notification handler code here
#if ALLOW_MOUSE_TO_REPEAT
	int i = 0;
	if (PreviousDebounceState == DEBOUNCE_STATE_DONE)
		i++;
	PreviousDebounceState = DEBOUNCE_STATE_IDLE;
	PreviousDebounce = 0;
	if (i)
		return;
#endif
	if (Data.CurrentIndex)
	{
		Data.CurrentIndex--;
		DecodeImageCurrentIndex();
		InvalidateDMDPages();
	}
	UpdateControls();
}

void DMD::InvalidateDMDPages()
{
	RECT ThisRect;
	GetClientRect(&ThisRect);
	ThisRect.bottom = ((DMD_ROWS + 1 + DMD_ROWS + 1 + DMD_ROWS) * PIXEL_HEIGHT);
	ThisRect.right = (DMD_COLUMNS * PIXEL_WIDTH);
	InvalidateRect(&ThisRect, FALSE);
}

void DMD::UpdateStaticTextBoxes()
{
	CString str;
	if (Data.Plane_0Status > PLANE_STATUS_IMAGEOUTOFRANGE)
		Data.Plane_0Status = PLANE_STATUS_IMAGEOUTOFRANGE;
	if (Data.Plane_1Status > PLANE_STATUS_IMAGEOUTOFRANGE)
		Data.Plane_1Status = PLANE_STATUS_IMAGEOUTOFRANGE;
	str.Format("Index %1.1u\n%s %1.1u Bytes",Data.CurrentIndex,StatusText[Data.Plane_0Status],Data.Plane_0Size);
	m_Medium.SetWindowText(str);
	str.Format("Index %1.1u\n%s %1.1u Bytes",(Data.CurrentIndex + 1), StatusText[Data.Plane_1Status],Data.Plane_1Size);
	m_Dim.SetWindowText(str);
	str.Format("Index %1.1u\n%s\n<and>\nIndex %1.1u\n%s",Data.CurrentIndex,StatusText[Data.Plane_0Status], (Data.CurrentIndex + 1),StatusText[Data.Plane_1Status]);
	m_Both.SetWindowText(str);
}

void DMD::UpdateControls()
{
	BOOL Enable;

	Enable = TRUE;
	if (!Data.CurrentIndex)
		Enable = FALSE;
	m_PreviousGraphic.EnableWindow(Enable);

	Enable = TRUE;
//	if (Data.CurrentIndex >= MAX_GRAPHIC_INDEX)
//		Enable = FALSE;
	m_NextGraphic.EnableWindow(Enable);
}

void DMD::OnCheckSkipped() 
{
	// TODO: Add your control notification handler code here
	InvalidateDMDPages();
}

void DMD::OnCheckXored() 
{
	// TODO: Add your control notification handler code here
	InvalidateDMDPages();
}


void DMD::OnSelchangeList1() 
{
	// TODO: Add your control notification handler code here
	InvalidateDMDPages();
}

void DMD::OnOK() 
{
	// TODO: Add extra validation here
	SaveDMDRegistrySettings();	
	CDialog::OnOK();
}

void DMD::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	SaveDMDRegistrySettings();	
	CDialog::OnClose();
}

void DMD::SaveDMDRegistrySettings()
{
	PassedInPointer->PixelColor = m_PixelColor.GetTopIndex();
	PassedInPointer->XoredCheckboxState = m_Xored.GetCheck();
	PassedInPointer->SkippedCheckboxState = m_Skipped.GetCheck();
	((CHexEditorApp *)AfxGetApp())->SaveProgramSettingsToRegistry(PassedInPointer);
}

void DMD::UpdateCheckboxText()
{
	CString CurrentText;
	CString DesiredText;
	int CurrentColor = m_PixelColor.GetTopIndex();
	int TextStringColor;
	TextStringColor = NORMAL_XORED_COLOR;
	if (CurrentColor == NORMAL_XORED_COLOR)
		TextStringColor = ALTERNATE_XORED_COLOR;
	DesiredText.Format("Show XORed pixels as %s",ColorText[TextStringColor]);
	m_Xored.GetWindowText(CurrentText);
	if (CurrentText != DesiredText)
		m_Xored.SetWindowText(DesiredText);

	TextStringColor = NORMAL_SKIPPED_COLOR;
	if (CurrentColor == NORMAL_SKIPPED_COLOR)
		TextStringColor = ALTERNATE_SKIPPED_COLOR;
	DesiredText.Format("Show Skipped pixels as %s",ColorText[TextStringColor]);
	m_Skipped.GetWindowText(CurrentText);
	if (CurrentText != DesiredText)
		m_Skipped.SetWindowText(DesiredText);
}

HBRUSH DMD::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{

	// TODO: Change any attributes of the DC here
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

//#define CTLCOLOR_MSGBOX         0
//#define CTLCOLOR_EDIT           1
//#define CTLCOLOR_LISTBOX        2
//#define CTLCOLOR_BTN            3
//#define CTLCOLOR_DLG            4
//#define CTLCOLOR_SCROLLBAR      5
//#define CTLCOLOR_STATIC         6
//#define CTLCOLOR_MAX            7
//	if (nCtlColor == CTLCOLOR_DLG)
//	{
//		pDC->SetTextColor(GetSysColor(COLOR_INACTIVECAPTION));
//		pDC->SetBkColor(RGB(0,0,0));
//		return (HBRUSH)(m_pListBkBrush->GetSafeHandle());
//	}
	return hbr;
}

void DMD::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	UpdateControls();
	GotoDlgCtrl (GetDlgItem(IDC_BUTTON_NEXT_GRAPHIC));
}

void DMD::OnTimer(UINT nIDEvent) 
{
#if ALLOW_MOUSE_TO_REPEAT

	// TODO: Add your message handler code here and/or call default
#define CLEAR_NEXT      0x01
#define CLEAR_PREVIOUS  0x02

	unsigned char Clear = (CLEAR_NEXT | CLEAR_PREVIOUS);

	if (nIDEvent == TIMER_DMD)
	{
		if (IsWindowVisible())
		{
			CPoint pos;
			CRect rec;
			BOOL LeftButtonDown = FALSE;
			if (GetSystemMetrics(SM_SWAPBUTTON))
			{
				if ((GetAsyncKeyState(VK_RBUTTON)) < 0)
					LeftButtonDown = TRUE;
			}
			else
			{
				if ((GetAsyncKeyState(VK_LBUTTON)) < 0)
					LeftButtonDown = TRUE;
			}
			if (LeftButtonDown == TRUE)
			{
				if (GetCursorPos(&pos))
				{
					m_NextGraphic.GetWindowRect(&rec);
					if (rec.PtInRect(pos)) 
					{
						Clear &= ~CLEAR_NEXT;
						switch (NextDebounceState)
						{
							case DEBOUNCE_STATE_DONE        :
								Data.CurrentIndex++;
								DecodeImageCurrentIndex();
								InvalidateDMDPages();
								UpdateControls();
								break;
							case DEBOUNCE_STATE_DEBOUNCING  :
								if (NextDebounce)
									NextDebounce--;
								if (!NextDebounce)
									NextDebounceState = DEBOUNCE_STATE_DONE;
								break;
							case DEBOUNCE_STATE_IDLE        :
							default :
								NextDebounce = (DEFAULT_DEBOUNCE_TIME / TIMER_DMD_UPDATE);
								NextDebounceState = DEBOUNCE_STATE_DEBOUNCING;
						}
					}
					else
					{
						m_PreviousGraphic.GetWindowRect(&rec);
						if ((rec.PtInRect(pos)) && (m_PreviousGraphic.GetFocus()))
						{
							Clear &= ~CLEAR_PREVIOUS;
							switch (PreviousDebounceState)
							{
								case DEBOUNCE_STATE_DONE        :
									if (Data.CurrentIndex)
									{
										Data.CurrentIndex--;
										DecodeImageCurrentIndex();
										InvalidateDMDPages();
										UpdateControls();
									}
									break;
								case DEBOUNCE_STATE_DEBOUNCING  :
									if (PreviousDebounce)
										PreviousDebounce--;
									if (!PreviousDebounce)
										PreviousDebounceState = DEBOUNCE_STATE_DONE;
									break;
								case DEBOUNCE_STATE_IDLE        :
								default :
									PreviousDebounce = (DEFAULT_DEBOUNCE_TIME / TIMER_DMD_UPDATE);
									PreviousDebounceState = DEBOUNCE_STATE_DEBOUNCING;
							}
						}
					}
				}
			}
		}
	}	
	if (Clear & CLEAR_NEXT)
	{
		NextDebounce = 0;
		NextDebounceState = DEBOUNCE_STATE_IDLE;
	}
	if (Clear & CLEAR_PREVIOUS)
	{
		PreviousDebounce = 0;
		PreviousDebounceState = DEBOUNCE_STATE_IDLE;
	}
	CDialog::OnTimer(nIDEvent);
#endif
}

void DMD::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	CPoint pos;
	CRect rec;
	int InButton = 0;
	if (GetCursorPos(&pos))
	{
		m_NextGraphic.GetWindowRect(&rec);
		if (rec.PtInRect(pos))
			InButton = 1;
		m_PreviousGraphic.GetWindowRect(&rec);
		if (rec.PtInRect(pos))
			InButton = 1;
	}
	if (!InButton)
		PostMessage(WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM(point.x, point.y));
	CDialog::OnLButtonDown(nFlags, point);
}

void DMD::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonUp(nFlags, point);
}
