/////////////////////////////////////////////////////////////////////////////
// HexEditor.cpp : Defines the class behaviors for the application.
// ----------------------------------------------------------------
// This code was written by Paul "Crazy" Frazee, and can be
// used royalty-free in any program. However, if the code is to be
// redistributed (in a modified state or not), I would appreciate
// an acknowledgement that the code was originally mine, or based
// off of mine. Please enjoy!
// 
// You can reach me at paulfrazee@cox.net, or CrazyFrazee911 (aim).
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#define STORE_HERE
#include "HexEditor.h"

#include "MainFrm.h"
#include "HexEditorDoc.h"
#include "HexEditorView.h"
#include "dmd.h"
#include "splasher.h"
#include "RegDialog.h"
#include "Nag.h"
#include "Unlock.h"
//#include "WinVer.h"  // used for getting version information from struct to About box
//#include "Windows.h"
#include "version.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CHexEditorApp

BEGIN_MESSAGE_MAP(CHexEditorApp, CWinApp)
	//{{AFX_MSG_MAP(CHexEditorApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHexEditorApp construction

CHexEditorApp::CHexEditorApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	delete pDocTemplate;
	ProgramInitialized = FALSE;
}



// <Splash>
class CMySplashWnd : public CSplashWnd
{
public:
//Constructors / Destructors
  CMySplashWnd();

  DECLARE_DYNCREATE(CMySplashWnd);
};

IMPLEMENT_DYNCREATE(CMySplashWnd, CSplashWnd);

CMySplashWnd::CMySplashWnd()
{
  //Use the following 2 lines of code if you would like a transparent splash screen
  SetBitmapToUse(IDB_TRANSPARENT_SPLASH);
//	CString SplashFileName;
//
//	CString m_sModuleFileName;
//	CString m_sModulePath;
//
//	int nResult = GetModuleFileName(AfxGetApp()->m_hInstance, m_sModuleFileName.GetBuffer(_MAX_PATH), _MAX_PATH);
//	                                m_sModuleFileName.ReleaseBuffer();
//    
//    if (nResult > 0)
//    {                 
//		int nPos;
//  		if ((nPos = m_sModuleFileName.ReverseFind('\\')) > -1)
//			m_sModulePath = m_sModuleFileName.Left(nPos);
//	}
//	SplashFileName.Format("%s\\Logo.Dib",Directory.GetBuffer(Directory.GetLength()));
//	SplashFileName = m_sModulePath + '\\' + SPLASH_FILE_NAME;
//	SetBitmapToUse("LOGO.DIB");
//	SetBitmapToUse(SplashFileName);
//	((CRadarLogApp *)AfxGetApp())->DetermineSplashFileName(&SplashFileName);
//	SetBitmapToUse(SplashFileName);

	SetTransparent();

  //Use the following section if you would like a standard rectangular window
  //SetBitmapToUse(IDB_SPLASH);
  //SetDropShadow(); //Please note that using a drop shadow in addition to transparency
                     //will produce unwanted visual artifacts as Windows is not smart enough
                     //to properly do drop shadows for transparent windows. You would be
                     //better advised to produce a drop shadow in your bitmap using your
                     //favorite graphics editor (Just like what the IDB_TRANSPARENT_SPLASH
                     //bitmap
}

// </Splash>


/////////////////////////////////////////////////////////////////////////////
// The one and only CHexEditorApp object

CHexEditorApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHexEditorApp initialization

BOOL CHexEditorApp::InitInstance()
{
//#if SPECIAL_UNLOCK_BUILD
#ifdef UNLOCKBUILD
	Unlock UnlockDialog;
	UnlockDialog.DoModal();
	m_pMainWnd = NULL;
	return FALSE;
#else
	int Confuse1; // v1.2 adding nonsense code...
	int Confuse2; // v1.2 adding nonsense code...
	int Confuse3; // v1.2 adding nonsense code...
	//
	// Here is a verification of our file integrity...
	//
	unsigned int  i;
	unsigned int Length;
	unsigned char TempByte;
	const char *Ptr;
	unsigned char XorValue = 0x00;
	unsigned char XorSum   = MYXOR_SEED;
	unsigned int  CheckSum = 0x0000;
	Length = strlen(MyInfo);
	Confuse1 = MYXOR_SEED - 5;
	for (i = 0, Ptr = &MyInfo[0]; i < Length; i++)
	{
		Confuse3++;
		TempByte = *Ptr++;
		XorValue ^= TempByte;
		XorSum   += XorValue;
		CheckSum += TempByte;
		Confuse1 ^= XorValue;
		Confuse2 += Confuse1 + TempByte + 1;
	}
	if (Confuse1 == Confuse2)
	{
		XorValue = XorSum + (CheckSum & 0xFF);
		Confuse3 = 0xFEED;
	}

	if ((XorValue != MY_XOR) || (XorSum != MY_XORSUM) || ((CheckSum & 0xFFFF) != MY_CSUM) || (Length != MY_LENGTH))
	{
		m_pMainWnd = NULL;
		return FALSE;
	}

	Confuse1   =
	Confuse2   =
	XorValue   = 0x00;
	Confuse3   =
	XorSum     = REGDLGXOR_SEED;
	CheckSum   = 0x0000;
	Length = strlen(RegDialogText);
	for (i = 0, Ptr = &RegDialogText[0]; i < Length; i++)
	{
		Confuse2 = 0xAA + CheckSum;
		TempByte = *Ptr++;
		Confuse1 = TempByte + (CheckSum - Confuse2);
		XorValue ^= TempByte;
		XorSum   += XorValue;
		CheckSum += TempByte;
		Confuse3 ^= Confuse1;
	}
	if ((((Confuse3 - Confuse2) + (Confuse1 ^ XorValue)) + 2) == ((Confuse3 ^ XorSum) - 2))
	{
		m_pMainWnd = NULL;
		return FALSE;
	}

	if ((XorValue != REGDLG_XOR) || (XorSum != REGDLG_XORSUM) || ((CheckSum & 0xFFFF) != REGDLG_CSUM) || (Length != REGDLG_LENGTH))
	{
		m_pMainWnd = NULL;
		return FALSE;
	}

	Confuse3   =
	XorValue   = 0x00;
	Confuse1   =
	Confuse2   =
	XorSum     = NAGDLGXOR_SEED;
	CheckSum   = 0x0000;
	Length = strlen(NagText);
	for (i = 0, Ptr = &NagText[0]; i < Length; i++)
	{	
		TempByte = *Ptr++;
		Confuse1 += TempByte;
		XorValue ^= TempByte;
		Confuse2 ^= XorValue;
		XorSum   += XorValue;
		Confuse3 -= XorSum;
		CheckSum += TempByte;
		Confuse1 += Confuse3 + 1;
	}
	if (Confuse1 == Confuse2)
		XorValue = CheckSum - XorSum;
	if ((XorValue != NAGDLG_XOR) || (XorSum != NAGDLG_XORSUM) || ((CheckSum & 0xFFFF) != NAGDLG_CSUM) || (Length != NAGDLG_LENGTH))
	{
		m_pMainWnd = NULL;
		return FALSE;
	}

	Confuse1   =
	Confuse2   =
	XorValue   = 0x00;
	Confuse3   =
	XorSum     = DMDNAGDLGXOR_SEED;
	CheckSum   = 0x0000;
	Length = strlen(DMDNagText);
	for (i = 0, Ptr = &DMDNagText[0]; i < Length; i++)
	{	
		TempByte = *Ptr++;
		Confuse3 += TempByte;
		XorValue ^= TempByte;
		Confuse1 ^= XorValue;
		XorSum   += XorValue;
		Confuse3 -= XorSum;
		CheckSum += TempByte;
		Confuse1 += Confuse2 + 1;
	}
	if (Confuse1 == Confuse2)
		XorValue = CheckSum - XorSum;
	if ((XorValue != DMDNAGDLG_XOR) || (XorSum != DMDNAGDLG_XORSUM) || ((CheckSum & 0xFFFF) != DMDNAGDLG_CSUM) || (Length != DMDNAGDLG_LENGTH))
	{
		m_pMainWnd = NULL;
		return FALSE;
	}

	Confuse1   =
	Confuse2   =
	Confuse3   =
	XorValue   = 0x00;
	XorSum     = REGTEXTXOR_SEED;
	CheckSum   = 0x0000;
	Length = strlen(RegisteredText);
	for (i = 0, Ptr = &RegisteredText[0]; i < Length; i++)
	{	
		Confuse1 += i;
		Confuse2 += Confuse1;
		TempByte = *Ptr++;
		XorValue ^= TempByte;
		XorSum   += XorValue;
		Confuse3 += Confuse2 + REGTEXT_XOR;
		CheckSum += TempByte;
	}
	if ((XorValue != REGTEXT_XOR) || (XorSum != REGTEXT_XORSUM) || ((CheckSum & 0xFFFF) != REGTEXT_CSUM) || (Length != REGTEXT_LENGTH) || (Confuse3 == Confuse2))
	{
		m_pMainWnd = NULL;
		return FALSE;
	}

	Confuse3   =
	Confuse2   =
	XorValue   = 0x00;
	Confuse1   =
	XorSum     = XOR_SEED;
	CheckSum   = 0x0000;
	Length = strlen(RegisteredUser);
	for (i = 0, Ptr = &RegisteredUser[0]; i < Length; i++)
	{
		Confuse3 ^= i;
		TempByte = *Ptr++;
		Confuse1 ^= TempByte;
		XorValue ^= TempByte;
		XorSum   += XorValue;
		Confuse2 += XorValue + REG_XOR + Confuse1;
		CheckSum += TempByte;
	}
	if (Confuse2 == Confuse1)
		CheckSum = XorValue ^ Length ^ XorSum;
	CheckSum &= 0xFFFF;
	if (   (Length != REG_LENGTH)
		|| (CheckSum != REG_CSUM)
		|| (XorValue != REG_XOR)
		|| (XorSum != REG_XORSUM)
       )
	{
		m_pMainWnd = NULL;
		return FALSE;
	}

    // Start of one-instance code
	// Check if program is already running
    bool AlreadyRunning;
    HANDLE hMutexOneInstance = ::CreateMutex( NULL, FALSE,
		_T("WPCEDIT-F27C57BF-AF6A-4ffe-A445-994C232741FE"));

    // what changes for the alternative solutions
    // is the UID in the above call
    // which will be replaced by a call on
    // createExclusionName

    AlreadyRunning = ( ::GetLastError() == ERROR_ALREADY_EXISTS || 
                       ::GetLastError() == ERROR_ACCESS_DENIED);
    // The call fails with ERROR_ACCESS_DENIED if the Mutex was 
    // created in a different users session because of passing
    // NULL for the SECURITY_ATTRIBUTES on Mutex creation);

    if ( AlreadyRunning )
	{ // kill this 
		HWND hOther = NULL;
        EnumWindows(searcher, (LPARAM)&hOther);

        if ( hOther != NULL )
	    { // pop up 
             ::SetForegroundWindow( hOther );

             if ( IsIconic( hOther ) )
             { // restore 
                 ::ShowWindow( hOther, SW_RESTORE );
             } // restore 
        } // pop up 

        return FALSE; // terminates the creation
    } // kill this 
    // ... continue with InitInstance
	// End of one-instance code


	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("WPCEdit"));


	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	LoadProgramSettings(&ProgramSettings);


	//
	// Unique computer ID check
	//
#ifdef PUBLIC_RELEASE
	long id = 0x3B03FCE9;  // laptop hard drive ID, default for public release
#else
	long id = (getHardDriveComputerID () ^ REG_INITIAL_ID_XOR) & 0xFFFFF00F;
#endif

	id |= (unsigned int)((REG_XOR ^ REG_UNIQUE_ID_XOR) << 4);
	
	long xor = ((CheckSum << 16) + (XorValue << 8) + (XorSum));
	unsigned char MD5[MD5_HASH_SIZE];
	unsigned char *MD5Ptr = MD5;

	xor ^= id;
	Confuse1 = Confuse2 = xor;
	Confuse3 = id;
	*MD5Ptr++ = (xor >> 24) & 0xFF;
	*MD5Ptr++ = (xor >> 16) & 0xFF;
	*MD5Ptr++ = (xor >> 8) & 0xFF;
	*MD5Ptr   = (xor & 0xFF);
	CalculateMD5(MD5, 4, MD5);                        // TEST:CurtLaven
	if ((                                             // LOCK:1A409ED3
		  ((((MD5[0]) & 0xFF) << 24) +                // UNLOCK:789F1E8D
	 	   (((MD5[1]) & 0xFF) << 16) +
		   (((MD5[2]) & 0xFF) << 8) +
		   ((MD5[3]) & 0xFF)
		  )
		  != ProgramSettings.UnlockKey)
		  ||
		  (Confuse3 == Confuse2))
	{
		RegDialog Reg(AfxGetMainWnd(), &MD5[0], id);
		int i;
		for (i = 0; i < MD5_HASH_SIZE; i++)
			MD5[i] = 0x00;

#ifdef PUBLIC_RELEASE
		MD5[0] = 'A';
		MD5[1] = 'A';
		MD5[2] = '2';
		MD5[3] = 'C';
		MD5[4] = '0';
		MD5[5] = '5';
		MD5[6] = '4';
		MD5[7] = '6';
#else
		switch (Reg.DoModal())
		{
			case IDOK :
				{
#endif

					MD5[8] = 0x00; // ensure null is there
					long UserValue;
					unsigned char ch;
					MD5Ptr = &MD5[0];
					for (i = UserValue = 0; i < 8; i++)
					{
						ch = *MD5Ptr++;
						for (Confuse1 = 0; Confuse1 < (id & 0x0FFF); Confuse1++)
						{
							Confuse3 ^= (ch + (Confuse1 ^ REG_XOR));
							while ((Confuse3--) & 0x03)
							{
								Confuse2 ^= Confuse1;
								Confuse2 += Confuse1;
							}
						}
						if (!ch)
							break;
						ch = toupper(ch);
						if ((ch >= '0') && (ch <= '9'))
							ch -= 0x30;
						else if ((ch >= 'A') && (ch <= 'F'))
							ch -= 0x37;
						else
							ch = 0x00;
						UserValue <<= 4;
						do
						{
							Confuse1 ^= (UserValue + Confuse2);
							Confuse3 += Confuse1;
						}
						while ((Confuse2--) & 0x07);
						if (Confuse3 != Confuse1)
							UserValue += ch;
					}
					MD5Ptr = &MD5[0];
					Confuse1 = *MD5Ptr;
					Confuse2 = *(MD5Ptr + 2);
					Confuse3 = *(MD5Ptr + 1);
					*MD5Ptr++ = (xor >> 24) & 0xFF;
					do
					{
						Confuse1 >>= Confuse1;
					} while ((Confuse3--) & 0x1F);
					*MD5Ptr++ = (xor >> 16) & 0xFF;
					for (; Confuse3 < Confuse1; Confuse3++)
					{
						Confuse2 += *(MD5Ptr - 1);
					}
					if (Confuse3 != Confuse1)
					*MD5Ptr++ = (xor >> 8) & 0xFF;
					*MD5Ptr   = (xor & 0xFF);
					while ((Confuse3--) & 0x7F)
						*MD5Ptr = (xor & 0xFF);
					if ((Confuse3 & 0x07) == 0x07)
					CalculateMD5(MD5, 4, MD5);
					if (
						  ((((MD5[0]) & 0xFF) << 24) +
	 					   (((MD5[1]) & 0xFF) << 16) +
						   (((MD5[2]) & 0xFF) << 8) +
						   ((MD5[3]) & 0xFF)
						  )
						  != UserValue)
					{
						AfxMessageBox("Invalid Key");
						m_pMainWnd = NULL;
						return FALSE;
					}
					ProgramSettings.UnlockKey = UserValue;
					SaveProgramSettingsToRegistry(&ProgramSettings);

#ifndef PUBLIC_RELEASE
				}
				break;		
			case IDCANCEL	:
			default	:
				m_pMainWnd = NULL;
				return FALSE;
		}
#endif

	}

	ProgramSettings.DiskId = id; // Save off the disk id for usage later (for more verifications)

	if (!(ProgramSettings.NagMessageShown))
	{
		Nag NagDialog;
		switch (NagDialog.DoModal())
		{
			case IDOK :
				ProgramSettings.NagMessageShown = TRUE;
				SaveProgramSettingsToRegistry(&ProgramSettings);
				break;
			case IDCANCEL :
			default:
				m_pMainWnd = NULL;
				return FALSE;
		}
	}
	//
	// BEGIN Splash screen addition
	// Important to do this AFTER the INI loading because we get some settings
	// regarding the splash screen from the INI file, also need to load up the
	// current run-time path from the GetModuleInfo() call above...
	//
	CSplashFactory factory;
	if (factory.Create(RUNTIME_CLASS(CMySplashWnd)))
		Sleep(1000);
	// END splash screen code addition

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

//	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CHexEditorDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CHexEditorView));
	AddDocTemplate(pDocTemplate);
//	delete pDocTemplate;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

//	LoadProgramSettings(&ProgramSettings);
	SaveProgramSettingsToRegistry(&ProgramSettings);

	// The one and only window has been initialized, so show and update it.
// The following 2 lines are now moved into the following SetupWindowStartup()
// which ensures the window is visible or properly minimized.
//	m_pMainWnd->ShowWindow(SW_SHOW);
//	m_pMainWnd->UpdateWindow();

	//FOLLOWING LINE IS THE ADDITION OF SPLASH SCREEN COMPONENT (if you forget to 
	//call close, it will be done for you automatically when "factory" goes out
	//of scope!!. 
	factory.Close();

	// The one and only window has been initialized, so show and update it.
	((CMainFrame *)m_pMainWnd)->SetupWindowStartup();

	DMDDialogPtr = new DMD(NULL, &ProgramSettings); // The DMD Dialog may modify the settings and registry when OK is clicked
	DMDDialogPtr->Create();
	
//AfxMessageBox("This is a super-duper non-release beta version that has limited use.");
	ProgramInitialized = TRUE;
	return TRUE;
#endif
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CStatic	m_VER;
	CStatic	m_CR;
	CStatic	m_AboutIcon;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

private:
	UINT IconAboutTimer;
	int IconIndex;
// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
	IconIndex = 0;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_STATIC_VER, m_VER);
	DDX_Control(pDX, IDC_STATIC_CR, m_CR);
	DDX_Control(pDX, IDC_STATIC_ABOUTICON, m_AboutIcon);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CHexEditorApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CHexEditorApp message handlers


int CHexEditorApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
	delete DMDDialogPtr;	
	return CWinApp::ExitInstance();
}

// One-instance code
BOOL CALLBACK CHexEditorApp::searcher(HWND hWnd, LPARAM lParam)
{
	DWORD result;

    LRESULT ok = ::SendMessageTimeout(hWnd,
                                      UWM_ARE_YOU_ME,
                                      0, 0, 
                                      SMTO_BLOCK |
//                                      SMTO_ABORT_IF_HUNG,
                                      SMTO_ABORTIFHUNG,
                                      200,
                                      &result);
    if(ok == 0)
		return TRUE; // ignore this and continue
    if(result == UWM_ARE_YOU_ME)
    { /* found it */
		HWND * target = (HWND *)lParam;
        *target = hWnd;
        return FALSE; // stop search
    } /* found it */
	return TRUE; // continue search
} // CMyApp::searcher

LRESULT CMainFrame::OnAreYouMe(WPARAM, LPARAM)
{
	return UWM_ARE_YOU_ME;
} // CMainFrame::OnAreYouMe
// One-instance code


int CAboutDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	IconAboutTimer = SetTimer(TIMER_ABOUT_ICON, TIMER_ABOUTICON_INITIAL, NULL);
	return 0;
}

void CAboutDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	if (IconAboutTimer)
		KillTimer(IconAboutTimer);	
}

void CAboutDlg::OnTimer(UINT nIDEvent) 
{
//	static int icons[] = 
//	{IDI_ICON28, IDI_ICON29, IDI_ICON30,
//	 IDI_ICON31, IDI_ICON32, IDI_ICON33,
//	 IDI_ICON34, IDI_ICON35, IDI_ICON36,
//	 IDI_ICON37, IDI_ICON38, IDI_ICON39,
//	 IDI_ICON40, IDI_ICON41, IDI_ICON42,
//	 IDI_ICON43, IDI_ICON44};

	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == TIMER_ABOUT_ICON)
	{

		CRect rect;
		int NewTimer;
		m_AboutIcon.GetWindowRect(rect);

		HICON hIconNew = AfxGetApp()->LoadIcon((UINT)icons[IconIndex++]);

		m_AboutIcon.SetIcon(hIconNew);
		m_AboutIcon.InvalidateRect(NULL, TRUE);

		if (IconIndex >= (sizeof(icons) / sizeof(icons[0])))  
			IconIndex = 0;
		switch (IconIndex)
		{
			case 1: // We just drew the initial image..
				NewTimer = TIMER_ABOUTICON_INITIAL;
				break;
			case 0: // We just finished the text animation...
				NewTimer = TIMER_ABOUTICON_AXED;
				break;
			default : // otherwise we're in animation mode wait .1 seconds				 
				NewTimer = TIMER_ABOUTICON_ANIMATING;
		}
		if (IconAboutTimer)
		{
			KillTimer(IconAboutTimer);	
			IconAboutTimer = SetTimer(TIMER_ABOUT_ICON, NewTimer, NULL);
		}
	}
	CDialog::OnTimer(nIDEvent);
}


void CHexEditorApp::LoadFactoryDefaultProgramSettings(RegistrySettings *Ptr)
{
	Ptr->UnlockKey = DEFAULT_UNLOCKKEY;
	Ptr->PixelColor = DEFAULT_PIXEL_COLOR;
	Ptr->XoredCheckboxState = DEFAULT_XORCHECKBOXSTATE;
	Ptr->SkippedCheckboxState = DEFAULT_SKIPCHECKBOXSTATE;
	Ptr->NagMessageShown = FALSE;
	Ptr->DMDNagMessageShown = FALSE;
	int i;
	for (i = 0; i < MAX_NAGS; i++)
		Ptr->MiscNagsShown[i] = FALSE;
}


void CHexEditorApp::LoadProgramSettings(RegistrySettings *Ptr)
{
	LoadFactoryDefaultProgramSettings(Ptr);
	Ptr->UnlockKey = GetProfileInt(REGISTRY_OVERALL_SETTINGS,"UnlockKey",Ptr->UnlockKey);
	Ptr->PixelColor = GetProfileInt(REGISTRY_DMDEDIT_SETTINGS,"PixelColor",Ptr->PixelColor);
	Ptr->XoredCheckboxState = GetProfileInt(REGISTRY_DMDEDIT_SETTINGS, "XorCheckbox",Ptr->XoredCheckboxState);
	Ptr->SkippedCheckboxState = GetProfileInt(REGISTRY_DMDEDIT_SETTINGS, "SkipCheckbox",Ptr->SkippedCheckboxState);
	Ptr->DMDNagMessageShown = GetProfileInt(REGISTRY_DMDEDIT_SETTINGS, "DMDNagScreenShown", Ptr->DMDNagMessageShown);
	Ptr->NagMessageShown = GetProfileInt(REGISTRY_NAG_SCREENS,"DisclaimerShown",Ptr->NagMessageShown);
	int i;
	for (i = 0; i < MAX_NAGS; i++)
		Ptr->MiscNagsShown[i] = GetProfileInt(REGISTRY_NAG_SCREENS,NagRegistryKeyText[i],Ptr->MiscNagsShown[i]);
	ValidateProgramSettings(Ptr);
}	

void CHexEditorApp::SaveProgramSettingsToRegistry(RegistrySettings *Ptr)
{
	ValidateProgramSettings(Ptr);
	WriteProfileInt(REGISTRY_OVERALL_SETTINGS, "UnlockKey", Ptr->UnlockKey);
	WriteProfileInt(REGISTRY_DMDEDIT_SETTINGS, "PixelColor", Ptr->PixelColor);
	WriteProfileInt(REGISTRY_DMDEDIT_SETTINGS, "XorCheckbox", Ptr->XoredCheckboxState);
	WriteProfileInt(REGISTRY_DMDEDIT_SETTINGS, "SkipCheckbox", Ptr->SkippedCheckboxState);
	WriteProfileInt(REGISTRY_DMDEDIT_SETTINGS, "DMDNagScreenShown", Ptr->DMDNagMessageShown);
	WriteProfileInt(REGISTRY_NAG_SCREENS, "DisclaimerShown", Ptr->NagMessageShown);
	int i;
	for (i = 0; i < MAX_NAGS; i++)
		WriteProfileInt(REGISTRY_NAG_SCREENS,NagRegistryKeyText[i],Ptr->MiscNagsShown[i]);
}

void CHexEditorApp::ValidateProgramSettings(RegistrySettings *Ptr)
{
	if (Ptr->PixelColor >= PIXEL_COLORS)
		Ptr->PixelColor = DEFAULT_PIXEL_COLOR;
	if (Ptr->XoredCheckboxState > 1)  // enforce our 1-or-0 values
		Ptr->XoredCheckboxState = 1;
	if (Ptr->SkippedCheckboxState > 1)
		Ptr->SkippedCheckboxState = 1;
}

//----------------------------------------------------------------------------------//
//                                                                                  //
// MD5 Protocol Stuff...
//                                                                                  //
//----------------------------------------------------------------------------------//
/*
  Copyright (C) 1999 Aladdin Enterprises.  All rights reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  L. Peter Deutsch
  ghost@aladdin.com

 */
/*$Id: md5.c $ */
/*
  Independent implementation of MD5 (RFC 1321).

  This code implements the MD5 Algorithm defined in RFC 1321.
  It is derived directly from the text of the RFC and not from the
  reference implementation.

  The original and principal author of md5.c is L. Peter Deutsch
  <ghost@aladdin.com>.  Other authors are noted in the change history
  that follows (in reverse chronological order):

  1999-11-04 lpd Edited comments slightly for automatic TOC extraction.
  1999-10-18 lpd Fixed typo in header comment (ansi2knr rather than md5).
  1999-05-03 lpd Original version.
 */

// 3M modification of original code, removed the 'TEST' check and hard-coded
// the #if 1 or #if 0.

//#ifdef TEST
//#if 1
// MFC build comments out the following include
//#include <string.h>     // 3M moved this #include here to get compile with #if 0 here
#if 0
/*
 * Compile with -DTEST to create a self-contained executable test program.
 * The test program should print out the same values as given in section
 * A.5 of RFC 1321, reproduced below.
 */
//#include <string.h>   // 3M removed this line, moved it up above the #if 0
main()
{
	static const char *const test[7] =
	{
		"", /*d41d8cd98f00b204e9800998ecf8427e*/
		"a", /*0cc175b9c0f1b6a831c399e269772661*/
		"abc", /*900150983cd24fb0d6963f7d28e17f72*/
		"message digest", /*f96b697d7cb7938d525a2f31aaf161d0*/
		"abcdefghijklmnopqrstuvwxyz", /*c3fcd3d76192e4007dfb496cca67e13b*/
		"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
					/*d174ab98d277d9f5a5611c2c9f419d9f*/
		"12345678901234567890123456789012345678901234567890123456789012345678901234567890"
					/*57edf4a22be3c955ac49da2e2107b67a*/
	};

	int i;

	for (i = 0; i < 7; ++i)
	{
		md5_state_t state;
		md5_byte_t digest[16];

		int di;

		md5_init(&state);
		md5_append(&state, (const md5_byte_t *)test[i], strlen(test[i]));
		md5_finish(&state, digest);
		printf("MD5 (\"%s\") = ", test[i]);
		for (di = 0; di < 16; ++di)
			 printf("%02x", digest[di]);
		printf("\n");
	}
	return 0;
}
#endif /* TEST */
//----------------------------------------------------------------------------//
//                                                                            //
// CalculateMD5()                                                             //
//                                                                            //
// This function is modeled after the original main() in this public domain   //
// source file.  It is designed to take in a source pointer (test) of size    //
// (size) and write the MD5 output to the destination buffer (digest).        //
//                                                                            //
//----------------------------------------------------------------------------//
void CHexEditorApp::CalculateMD5(BYTE *test, UINT size, BYTE *digest)
{
	md5_state_t state;

	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)test, size);
	md5_finish(&state, digest);
}


// This TestMD5() function is for testing the 3M CalculateMD5() function only.
// It is designed to be used with debugger to check digest values to make
// sure that CalculateMD5() is creating the correct digest with the sample
// values.
//
// This function has successfully revealed that the function CalculateMD5()
// will fill the digest buffer with the same results as expected for PC104
// builds, may need re-tested for ECM-XT builds.
//
//
//void TestMD5(void)
//{
//	static char *const test[7] =
//	{
//		"", /*d41d8cd98f00b204e9800998ecf8427e*/
//		"a", /*0cc175b9c0f1b6a831c399e269772661*/
//		"abc", /*900150983cd24fb0d6963f7d28e17f72*/
//		"message digest", /*f96b697d7cb7938d525a2f31aaf161d0*/
//		"abcdefghijklmnopqrstuvwxyz", /*c3fcd3d76192e4007dfb496cca67e13b*/
//		"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
//					/*d174ab98d277d9f5a5611c2c9f419d9f*/
//		"12345678901234567890123456789012345678901234567890123456789012345678901234567890"
//					/*57edf4a22be3c955ac49da2e2107b67a*/
//	};
//	int i;
//	unsigned char digest[16];
//	for (i = 0; i < 7; i++)
//		CalculateMD5(test[i], strlen(test[i]), digest);
//}

// 3M ADDITIONS END

/*
 * For reference, here is the program that computed the T values.
 */
#if 0
#include <math.h>
main()
{
	int i;
	for (i = 1; i <= 64; ++i)
	{
		unsigned long v = (unsigned long)(4294967296.0 * fabs(sin((double)i)));
		printf("#define T%d 0x%08lx\n", i, v);
	}
	return 0;
}
#endif
/*
 * End of T computation program.
 */
#define T1 0xd76aa478
#define T2 0xe8c7b756
#define T3 0x242070db
#define T4 0xc1bdceee
#define T5 0xf57c0faf
#define T6 0x4787c62a
#define T7 0xa8304613
#define T8 0xfd469501
#define T9 0x698098d8
#define T10 0x8b44f7af
#define T11 0xffff5bb1
#define T12 0x895cd7be
#define T13 0x6b901122
#define T14 0xfd987193
#define T15 0xa679438e
#define T16 0x49b40821
#define T17 0xf61e2562
#define T18 0xc040b340
#define T19 0x265e5a51
#define T20 0xe9b6c7aa
#define T21 0xd62f105d
#define T22 0x02441453
#define T23 0xd8a1e681
#define T24 0xe7d3fbc8
#define T25 0x21e1cde6
#define T26 0xc33707d6
#define T27 0xf4d50d87
#define T28 0x455a14ed
#define T29 0xa9e3e905
#define T30 0xfcefa3f8
#define T31 0x676f02d9
#define T32 0x8d2a4c8a
#define T33 0xfffa3942
#define T34 0x8771f681
#define T35 0x6d9d6122
#define T36 0xfde5380c
#define T37 0xa4beea44
#define T38 0x4bdecfa9
#define T39 0xf6bb4b60
#define T40 0xbebfbc70
#define T41 0x289b7ec6
#define T42 0xeaa127fa
#define T43 0xd4ef3085
#define T44 0x04881d05
#define T45 0xd9d4d039
#define T46 0xe6db99e5
#define T47 0x1fa27cf8
#define T48 0xc4ac5665
#define T49 0xf4292244
#define T50 0x432aff97
#define T51 0xab9423a7
#define T52 0xfc93a039
#define T53 0x655b59c3
#define T54 0x8f0ccc92
#define T55 0xffeff47d
#define T56 0x85845dd1
#define T57 0x6fa87e4f
#define T58 0xfe2ce6e0
#define T59 0xa3014314
#define T60 0x4e0811a1
#define T61 0xf7537e82
#define T62 0xbd3af235
#define T63 0x2ad7d2bb
#define T64 0xeb86d391

void CHexEditorApp::md5_process(md5_state_t *pms, const md5_byte_t *data /*[64]*/)
{
	md5_word_t a = pms->abcd[0],
				  b = pms->abcd[1],
				  c = pms->abcd[2],
				  d = pms->abcd[3];
	md5_word_t t;

// 3M DMS Code modification over original Aladdin Enterprises code.  Commented
// out following and using hard-coded #if 1 or #if 0

//#ifndef ARCH_IS_BIG_ENDIAN
//# define ARCH_IS_BIG_ENDIAN 1	/* slower, default implementation */
//#endif
//#if ARCH_IS_BIG_ENDIAN
#if 0 

	 /*
	  * On big-endian machines, we must arrange the bytes in the right
	  * order.  (This also works on machines of unknown byte order.)
	  */
	md5_word_t X[16];
	const md5_byte_t *xp = data;
	int i;

	for (i = 0; i < 16; ++i, xp += 4)
		X[i] = xp[0] + (xp[1] << 8) + (xp[2] << 16) + (xp[3] << 24);

#else  /* !ARCH_IS_BIG_ENDIAN */

	 /*
	  * On little-endian machines, we can process properly aligned data
	  * without copying it.
	  */
	md5_word_t xbuf[16];
	const md5_word_t *X;

	if (!((data - (const md5_byte_t *)0) & 3))
	{
		/* data are properly aligned */
		X = (const md5_word_t *)data;
	}
	else
	{
		/* not aligned */
		memcpy(xbuf, data, 64);
		X = xbuf;
	}
#endif

#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32 - (n))))

	/* Round 1. */
	/* Let [abcd k s i] denote the operation
	 a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
#define F(x, y, z) (((x) & (y)) | (~(x) & (z)))
#define MD5_SET(a, b, c, d, k, s, Ti)\
  t = a + F(b,c,d) + X[k] + Ti;\
  a = ROTATE_LEFT(t, s) + b
	 /* Do the following 16 operations. */
	 MD5_SET(a, b, c, d,  0,  7,  T1);
	 MD5_SET(d, a, b, c,  1, 12,  T2);
	 MD5_SET(c, d, a, b,  2, 17,  T3);
	 MD5_SET(b, c, d, a,  3, 22,  T4);
	 MD5_SET(a, b, c, d,  4,  7,  T5);
	 MD5_SET(d, a, b, c,  5, 12,  T6);
	 MD5_SET(c, d, a, b,  6, 17,  T7);
	 MD5_SET(b, c, d, a,  7, 22,  T8);
	 MD5_SET(a, b, c, d,  8,  7,  T9);
	 MD5_SET(d, a, b, c,  9, 12, T10);
	 MD5_SET(c, d, a, b, 10, 17, T11);
	 MD5_SET(b, c, d, a, 11, 22, T12);
	 MD5_SET(a, b, c, d, 12,  7, T13);
	 MD5_SET(d, a, b, c, 13, 12, T14);
	 MD5_SET(c, d, a, b, 14, 17, T15);
	 MD5_SET(b, c, d, a, 15, 22, T16);
#undef MD5_SET

	  /* Round 2. */
	  /* Let [abcd k s i] denote the operation
			 a = b + ((a + G(b,c,d) + X[k] + T[i]) <<< s). */
#define G(x, y, z) (((x) & (z)) | ((y) & ~(z)))
#define MD5_SET(a, b, c, d, k, s, Ti)\
  t = a + G(b,c,d) + X[k] + Ti;\
  a = ROTATE_LEFT(t, s) + b
	  /* Do the following 16 operations. */
	 MD5_SET(a, b, c, d,  1,  5, T17);
	 MD5_SET(d, a, b, c,  6,  9, T18);
	 MD5_SET(c, d, a, b, 11, 14, T19);
	 MD5_SET(b, c, d, a,  0, 20, T20);
	 MD5_SET(a, b, c, d,  5,  5, T21);
	 MD5_SET(d, a, b, c, 10,  9, T22);
	 MD5_SET(c, d, a, b, 15, 14, T23);
	 MD5_SET(b, c, d, a,  4, 20, T24);
	 MD5_SET(a, b, c, d,  9,  5, T25);
	 MD5_SET(d, a, b, c, 14,  9, T26);
	 MD5_SET(c, d, a, b,  3, 14, T27);
	 MD5_SET(b, c, d, a,  8, 20, T28);
	 MD5_SET(a, b, c, d, 13,  5, T29);
	 MD5_SET(d, a, b, c,  2,  9, T30);
	 MD5_SET(c, d, a, b,  7, 14, T31);
	 MD5_SET(b, c, d, a, 12, 20, T32);
#undef MD5_SET

	  /* Round 3. */
	  /* Let [abcd k s t] denote the operation
			 a = b + ((a + H(b,c,d) + X[k] + T[i]) <<< s). */
#define H(x, y, z) ((x) ^ (y) ^ (z))
#define MD5_SET(a, b, c, d, k, s, Ti)\
  t = a + H(b,c,d) + X[k] + Ti;\
  a = ROTATE_LEFT(t, s) + b
	  /* Do the following 16 operations. */
	 MD5_SET(a, b, c, d,  5,  4, T33);
	 MD5_SET(d, a, b, c,  8, 11, T34);
	 MD5_SET(c, d, a, b, 11, 16, T35);
	 MD5_SET(b, c, d, a, 14, 23, T36);
	 MD5_SET(a, b, c, d,  1,  4, T37);
	 MD5_SET(d, a, b, c,  4, 11, T38);
	 MD5_SET(c, d, a, b,  7, 16, T39);
	 MD5_SET(b, c, d, a, 10, 23, T40);
	 MD5_SET(a, b, c, d, 13,  4, T41);
	 MD5_SET(d, a, b, c,  0, 11, T42);
	 MD5_SET(c, d, a, b,  3, 16, T43);
	 MD5_SET(b, c, d, a,  6, 23, T44);
	 MD5_SET(a, b, c, d,  9,  4, T45);
	 MD5_SET(d, a, b, c, 12, 11, T46);
	 MD5_SET(c, d, a, b, 15, 16, T47);
	 MD5_SET(b, c, d, a,  2, 23, T48);
#undef MD5_SET

	  /* Round 4. */
	  /* Let [abcd k s t] denote the operation
			 a = b + ((a + I(b,c,d) + X[k] + T[i]) <<< s). */
#define I(x, y, z) ((y) ^ ((x) | ~(z)))
#define MD5_SET(a, b, c, d, k, s, Ti)\
  t = a + I(b,c,d) + X[k] + Ti;\
  a = ROTATE_LEFT(t, s) + b
	  /* Do the following 16 operations. */
	 MD5_SET(a, b, c, d,  0,  6, T49);
	 MD5_SET(d, a, b, c,  7, 10, T50);
	 MD5_SET(c, d, a, b, 14, 15, T51);
	 MD5_SET(b, c, d, a,  5, 21, T52);
	 MD5_SET(a, b, c, d, 12,  6, T53);
	 MD5_SET(d, a, b, c,  3, 10, T54);
	 MD5_SET(c, d, a, b, 10, 15, T55);
	 MD5_SET(b, c, d, a,  1, 21, T56);
	 MD5_SET(a, b, c, d,  8,  6, T57);
	 MD5_SET(d, a, b, c, 15, 10, T58);
	 MD5_SET(c, d, a, b,  6, 15, T59);
	 MD5_SET(b, c, d, a, 13, 21, T60);
	 MD5_SET(a, b, c, d,  4,  6, T61);
	 MD5_SET(d, a, b, c, 11, 10, T62);
	 MD5_SET(c, d, a, b,  2, 15, T63);
	 MD5_SET(b, c, d, a,  9, 21, T64);
#undef MD5_SET

	  /* Then perform the following additions. (That is increment each
		  of the four registers by the value it had before this block
		  was started.) */
	 pms->abcd[0] += a;
	 pms->abcd[1] += b;
	 pms->abcd[2] += c;
	 pms->abcd[3] += d;
}

void CHexEditorApp::md5_init(md5_state_t *pms)
{
	 pms->count[0] = pms->count[1] = 0;
	 pms->abcd[0] = 0x67452301;
	 pms->abcd[1] = 0xefcdab89;
	 pms->abcd[2] = 0x98badcfe;
	 pms->abcd[3] = 0x10325476;
}

void CHexEditorApp::md5_append(md5_state_t *pms, const md5_byte_t *data, int nbytes)
{
	const md5_byte_t *p = data;
	int left = nbytes;
	int offset = (pms->count[0] >> 3) & 63;
	md5_word_t nbits = (md5_word_t)(nbytes << 3);

	if (nbytes <= 0)
		return;

	/* Update the message length. */
	pms->count[1] += nbytes >> 29;
	pms->count[0] += nbits;
	if (pms->count[0] < nbits)
		pms->count[1]++;

	 /* Process an initial partial block. */
	if (offset)
	{
		int copy = (offset + nbytes > 64 ? 64 - offset : nbytes);

		memcpy(pms->buf + offset, p, copy);
		if (offset + copy < 64)
			 return;
		p += copy;
		left -= copy;
		md5_process(pms, pms->buf);
	}

	/* Process full blocks. */
	for (; left >= 64; p += 64, left -= 64)
		md5_process(pms, p);

	/* Process a final partial block. */
	if (left)
		memcpy(pms->buf, p, left);
}

void CHexEditorApp::md5_finish(md5_state_t *pms, md5_byte_t digest[16])
{
	static const md5_byte_t pad[64] =
	{
		0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	};

	md5_byte_t data[8];
	int i;

	/* Save the length before padding. */
	for (i = 0; i < 8; ++i)
		data[i] = (md5_byte_t)(pms->count[i >> 2] >> ((i & 3) << 3));
	/* Pad to 56 bytes mod 64. */
	md5_append(pms, pad, ((55 - (pms->count[0] >> 3)) & 63) + 1);
	/* Append the length. */
	md5_append(pms, data, 8);
	for (i = 0; i < 16; ++i)
		digest[i] = (md5_byte_t)(pms->abcd[i >> 2] >> ((i & 3) << 3));
}


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
/*
	CString strInternalName;
	CString strFileVersion;
	CString strLegalCopyright;

	char pszAppName[512];
	char pszVerBuff[256];
	int	iVerBuffLen = 256;
	char pszLangBuff[256];
	int iLangBuffLen = 256;
	DWORD   dwScratch;
	DWORD * pdwLangChar;
	DWORD   dwInfSize ;
	UINT    uSize;
	BYTE *  pbyInfBuff;
	char    szVersion  [32];
	char    szResource [80];
	char *  pszVersion = szVersion;

	dwInfSize = GetFileVersionInfoSize (pszAppName, &dwScratch);

	if (dwInfSize)
	{
	  pbyInfBuff = new BYTE [dwInfSize];

	  if (pbyInfBuff)
	  {
		 ZeroMemory (pbyInfBuff, dwInfSize);

		 if (GetFileVersionInfo (pszAppName, 0, dwInfSize, pbyInfBuff))
		 {
			if (VerQueryValue (pbyInfBuff,
							   "\\VarFileInfo\\Translation",
							   (void**)(&pdwLangChar),
							   &uSize))
			{
			   if (VerLanguageName (LOWORD (*pdwLangChar),
									szResource,
									sizeof(szResource)))
			   {
				  strncpy (pszLangBuff, szResource, iLangBuffLen);
			   }
			   wsprintf (szResource, "\\StringFileInfo\\%04X%04X\\FileVersion",
						 LOWORD (*pdwLangChar), HIWORD (*pdwLangChar));

			   if (VerQueryValue (pbyInfBuff,
								  szResource,
								  (void**)(&pszVersion),
								  &uSize))
			   {
				  strncpy (pszVerBuff, pszVersion, iVerBuffLen-1);
				  strFileVersion = pszVersion;
			   }

			   wsprintf (szResource, "\\StringFileInfo\\%04X%04X\\InternalName",
						 LOWORD (*pdwLangChar), HIWORD (*pdwLangChar));
			   if (VerQueryValue (pbyInfBuff,
								  szResource,
								  (void**)(&pszVersion),
								  &uSize))
					strInternalName = pszVersion;

			   wsprintf (szResource, "\\StringFileInfo\\%04X%04X\\LegalCopyright",
						 LOWORD (*pdwLangChar), HIWORD (*pdwLangChar));
			   if (VerQueryValue (pbyInfBuff,
								  szResource,
								  (void**)(&pszVersion),
								  &uSize))
					strLegalCopyright = pszVersion;

			}
		 }
		 delete [] pbyInfBuff;
	  }
	}

	m_VER.SetWindowText(CString(strInternalName + " Version " + strFileVersion));
	m_CR.SetWindowText(strLegalCopyright);
*/
	CString InfoText;
#if CURRENT_USER == 004
	InfoText.Format("%s Version %.1fb",APPLICATION_TITLE,APPLICATION_VERSION);
#elif CURRENT_USER == 005
	InfoText.Format("%s Version %.1frs",APPLICATION_TITLE,APPLICATION_VERSION);
#else
	InfoText.Format("%s Version %.1f",APPLICATION_TITLE,APPLICATION_VERSION);
#endif
	m_VER.SetWindowText(InfoText);
	m_CR.SetWindowText(APPLICATION_COPYRIGHT);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
