// cv_201Dlg.h : header file
//

#if !defined(AFX_cv_201DLG_H__8916C740_3190_438D_AAE1_54F691046E62__INCLUDED_)
#define AFX_cv_201DLG_H__8916C740_3190_438D_AAE1_54F691046E62__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// Ccv_201cDlg dialog
//
//
#define ROM_FILESIZE               0x00100000   // Fixed value for cv_20h/cv_20hc ROM

#define CV201_CSUM_FIXUP_BYTE_ADDR (0x435CA)   // Known byte to play with for checksum
#define CV201_CSUM_NEW_VERSION          0x20   // Second byte of checksum

#define CV201_VERSION_MINOR_VALUE       0x01   // Makes it 2.01, when upgrading from 2.00 it shouldn't cause factory reset.
#define CV201_VERSION_MINOR_ADDR        0xFFFBF// Address where to put minor version value

#define CV201_UNUSED_BYTE_VAL           0xFF

// To determine if ROM is cv_20h or cv_20hc, check the ISR intercept.  If it is fixed up for coin-up when
// we're modifying the cv_20hc, else we're modifying cv_20h
#define CV201_ISR_JUMP_ADDR             0xFDDFF // Address in ROM where ISR get fixed up to call new ISR code in cv_20hc
#define CV201_ISR_JUMP_OLDVAL           0xDEFD  // WPC Call address in original cv_20h rom
#define CV201_ISR_JUMP_NEWVAL           0xFCF5  // WPC Call address put into the original ISR to cause jump to new ISR code

#define CV201_FIXUP_01_ADDR             0xF77BF // Address of solenoid-test knocker pulse time value
#define CV201_FIXUP_01_OLDVAL           0x00
#define CV201_FIXUP_01_NEWVAL           0x40

#define CV201_FIXUP_02_ADDR             0x42796 // Address of "NOT USED", Solenoid Test text pointer, English (Bank 0x10)
#define CV201_FIXUP_03_ADDR             0x46A3A // Address of "NOT USED", Solenoid Test text pointer, German  (Bank 0x11)
#define CV201_FIXUP_04_ADDR             0x4A992 // Address of "NOT USED", Solenoid Test text pointer, French  (Bank 0x12)
#define CV201_FIXUP_05_ADDR             0x4EA51 // Address of "NOT USED", Solenoid Test text pointer, Spanish (Bank 0x13)

#define CV201_FIXUP_02_NEWADDR          0x435CB // New ROM address for "KNOCKER", Solenoid test text, English (Bank 0x10)
#define CV201_FIXUP_03_NEWADDR          0x47940 // New ROM address for "KNOCKER", Solenoid test text, German  (Bank 0x11)
#define CV201_FIXUP_04_NEWADDR          0x4B941 // New ROM address for "KNOCKER", Solenoid test text, French  (Bank 0x12)
#define CV201_FIXUP_05_NEWADDR          0x4F8DA // New ROM address for "KNOCKER", Solenoid test text, Spanish (Bank 0x13)

#define CV201_FIXUP_02_OLDVAL           0x68B8  // Old pointer value for solenoid test table text, English (Bank 0x10)
#define CV201_FIXUP_03_OLDVAL           0x6B82  // Old pointer value for solenoid test table text, German  (Bank 0x11)
#define CV201_FIXUP_04_OLDVAL           0x6AED  // Old pointer value for solenoid test table text, French  (Bank 0x12)
#define CV201_FIXUP_05_OLDVAL           0x6B8A  // Old pointer value for solenoid test table text, Spanish (Bank 0x13)

#define CV201_FIXUP_02_NEWVAL           0x75CB  // New pointer value for solenoid test table text, English (Bank 0x10)
#define CV201_FIXUP_03_NEWVAL           0x7940  // New pointer value for solenoid test table text, German  (Bank 0x11)
#define CV201_FIXUP_04_NEWVAL           0x7941  // New pointer value for solenoid test table text, French  (Bank 0x12)
#define CV201_FIXUP_05_NEWVAL           0x78DA  // New pointer value for solenoid test table text, Spanish (Bank 0x13)



#define CV201_FIXUP_06_ADDR             0xF30A1 // Address of default-value for "Knocker Volume" adjustment
#define CV201_FIXUP_06_OLDVAL           0x1F
#define CV201_FIXUP_06_NEWVAL           0x00

#define CV201_FIXUP_07_ADDR             0xF7F48 // Address of knocker-solenoid lookup index
#define CV201_FIXUP_07_OLDVAL           0x00
#define CV201_FIXUP_07_NEWVAL           0x1C

#define CV201_FIXUP_08_ADDR             0x8F734 // Address of unused area to relocate the SolenoidTable[]
#define CV201_FIXUP_09_ADDR             0xF8205 // Address of SolenoidTable[] pointer in non-banked rom
#define CV201_FIXUP_09_OLDVAL           0x6629
#define CV201_FIXUP_09_NEWVAL           0x7734

#define CV201_FIXUP_10_ADDR             0xBB357 // Address of light-lock J110-3 assertion (prototype enable on unused output??)
#define CV201_FIXUP_11_ADDR             0xBB366 // Address of light-lock J110-3 de-assertion (prototype enable on unused output??)


class Ccv_201Dlg : public CDialog
{
// Construction
public:
	Ccv_201Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(Ccv_201Dlg)
	enum { IDD = IDD_cv_201_DIALOG };
	CStatic	m_Reg;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Ccv_201Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(Ccv_201Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_cv_20hcDLG_H__8916C740_3190_438D_AAE1_54F691046E62__INCLUDED_)
